<?php
/**
 * CustomerShippingAddressApi
 * PHP version 5
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * CyberSource Merged Spec
 *
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace CyberSource\Api;

use \CyberSource\ApiClient;
use \CyberSource\ApiException;
use \CyberSource\Configuration;
use \CyberSource\ObjectSerializer;

/**
 * CustomerShippingAddressApi Class Doc Comment
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerShippingAddressApi
{
    /**
     * API Client
     *
     * @var \CyberSource\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \CyberSource\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\CyberSource\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \CyberSource\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \CyberSource\ApiClient $apiClient set the API client
     *
     * @return CustomerShippingAddressApi
     */
    public function setApiClient(\CyberSource\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation deleteCustomerShippingAddress
     *
     * Delete a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of void, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteCustomerShippingAddress($customerTokenId, $shippingAddressTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->deleteCustomerShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation deleteCustomerShippingAddressWithHttpInfo
     *
     * Delete a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteCustomerShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $profileId = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling deleteCustomerShippingAddress');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'shippingAddressTokenId' is set
        if ($shippingAddressTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $shippingAddressTokenId when calling deleteCustomerShippingAddress');
        }
        if ((strlen($shippingAddressTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($shippingAddressTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be bigger than or equal to 1.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.deleteCustomerShippingAddress, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }
        // path params
        if ($shippingAddressTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "shippingAddressTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($shippingAddressTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}'
            );

            return [$response, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getCustomerShippingAddress
     *
     * Retrieve a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomerShippingAddress($customerTokenId, $shippingAddressTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->getCustomerShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getCustomerShippingAddressWithHttpInfo
     *
     * Retrieve a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomerShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $profileId = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling getCustomerShippingAddress');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'shippingAddressTokenId' is set
        if ($shippingAddressTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $shippingAddressTokenId when calling getCustomerShippingAddress');
        }
        if ((strlen($shippingAddressTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($shippingAddressTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be bigger than or equal to 1.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.getCustomerShippingAddress, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }
        // path params
        if ($shippingAddressTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "shippingAddressTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($shippingAddressTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress',
                '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getCustomerShippingAddressesList
     *
     * List Shipping Addresses for a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param int $offset Starting record in zero-based dataset that should be returned as the first object in the array. Default is 0. (optional, default to 0)
     * @param int $limit The maximum number that can be returned in the array starting from the offset record in zero-based dataset. Default is 20, maximum is 100. (optional, default to 20)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\ShippingAddressListForCustomer, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomerShippingAddressesList($customerTokenId, $profileId = null, $offset = '0', $limit = '20')
    {
        list($response, $statusCode, $httpHeader) = $this->getCustomerShippingAddressesListWithHttpInfo($customerTokenId, $profileId, $offset, $limit);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getCustomerShippingAddressesListWithHttpInfo
     *
     * List Shipping Addresses for a Customer
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param int $offset Starting record in zero-based dataset that should be returned as the first object in the array. Default is 0. (optional, default to 0)
     * @param int $limit The maximum number that can be returned in the array starting from the offset record in zero-based dataset. Default is 20, maximum is 100. (optional, default to 20)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\ShippingAddressListForCustomer, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomerShippingAddressesListWithHttpInfo($customerTokenId, $profileId = null, $offset = '0', $limit = '20')
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling getCustomerShippingAddressesList');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be bigger than or equal to 1.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be bigger than or equal to 36.');
        }

        if (!is_null($offset) && ($offset < 0)) {
            throw new \InvalidArgumentException('invalid value for "$offset" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be bigger than or equal to 0.');
        }

        if (!is_null($limit) && ($limit > 100)) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be smaller than or equal to 100.');
        }
        if (!is_null($limit) && ($limit < 1)) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling CustomerShippingAddressApi.getCustomerShippingAddressesList, must be bigger than or equal to 1.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}/shipping-addresses";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // query params
        if ($offset !== null) {
            $queryParams['offset'] = $this->apiClient->getSerializer()->toQueryValue($offset);
        }
        // query params
        if ($limit !== null) {
            $queryParams['limit'] = $this->apiClient->getSerializer()->toQueryValue($limit);
        }
        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\ShippingAddressListForCustomer',
                '/tms/v2/customers/{customerTokenId}/shipping-addresses'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\ShippingAddressListForCustomer', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\ShippingAddressListForCustomer', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation patchCustomersShippingAddress
     *
     * Update a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param \CyberSource\Model\PatchCustomerShippingAddressRequest $patchCustomerShippingAddressRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchCustomersShippingAddress($customerTokenId, $shippingAddressTokenId, $patchCustomerShippingAddressRequest, $profileId = null, $ifMatch = null)
    {
        list($response, $statusCode, $httpHeader) = $this->patchCustomersShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $patchCustomerShippingAddressRequest, $profileId, $ifMatch);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation patchCustomersShippingAddressWithHttpInfo
     *
     * Update a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param string $shippingAddressTokenId The TokenId of an shipping address. (required)
     * @param \CyberSource\Model\PatchCustomerShippingAddressRequest $patchCustomerShippingAddressRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchCustomersShippingAddressWithHttpInfo($customerTokenId, $shippingAddressTokenId, $patchCustomerShippingAddressRequest, $profileId = null, $ifMatch = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling patchCustomersShippingAddress');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'shippingAddressTokenId' is set
        if ($shippingAddressTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $shippingAddressTokenId when calling patchCustomersShippingAddress');
        }
        if ((strlen($shippingAddressTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($shippingAddressTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$shippingAddressTokenId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'patchCustomerShippingAddressRequest' is set
        if ($patchCustomerShippingAddressRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $patchCustomerShippingAddressRequest when calling patchCustomersShippingAddress');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be bigger than or equal to 36.');
        }

        if (!is_null($ifMatch) && (strlen($ifMatch) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be smaller than or equal to 32.');
        }
        if (!is_null($ifMatch) && (strlen($ifMatch) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling CustomerShippingAddressApi.patchCustomersShippingAddress, must be bigger than or equal to 1.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // header params
        if ($ifMatch !== null) {
            $headerParams['if-match'] = $this->apiClient->getSerializer()->toHeaderValue($ifMatch);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }
        // path params
        if ($shippingAddressTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "shippingAddressTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($shippingAddressTokenId),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($patchCustomerShippingAddressRequest)) {
            $_tempBody = $patchCustomerShippingAddressRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PATCH',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress',
                '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 412:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation postCustomerShippingAddress
     *
     * Create a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param \CyberSource\Model\PostCustomerShippingAddressRequest $postCustomerShippingAddressRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function postCustomerShippingAddress($customerTokenId, $postCustomerShippingAddressRequest, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->postCustomerShippingAddressWithHttpInfo($customerTokenId, $postCustomerShippingAddressRequest, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation postCustomerShippingAddressWithHttpInfo
     *
     * Create a Customer Shipping Address
     *
     * @param string $customerTokenId The TokenId of a customer. (required)
     * @param \CyberSource\Model\PostCustomerShippingAddressRequest $postCustomerShippingAddressRequest  (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress, HTTP status code, HTTP response headers (array of strings)
     */
    public function postCustomerShippingAddressWithHttpInfo($customerTokenId, $postCustomerShippingAddressRequest, $profileId = null)
    {
        // verify the required parameter 'customerTokenId' is set
        if ($customerTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $customerTokenId when calling postCustomerShippingAddress');
        }
        if ((strlen($customerTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.postCustomerShippingAddress, must be smaller than or equal to 32.');
        }
        if ((strlen($customerTokenId) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$customerTokenId" when calling CustomerShippingAddressApi.postCustomerShippingAddress, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'postCustomerShippingAddressRequest' is set
        if ($postCustomerShippingAddressRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $postCustomerShippingAddressRequest when calling postCustomerShippingAddress');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.postCustomerShippingAddress, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling CustomerShippingAddressApi.postCustomerShippingAddress, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v2/customers/{customerTokenId}/shipping-addresses";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($customerTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "customerTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($customerTokenId),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($postCustomerShippingAddressRequest)) {
            $_tempBody = $postCustomerShippingAddressRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress',
                '/tms/v2/customers/{customerTokenId}/shipping-addresses'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultShippingAddress', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
