<?php
/**
 * InstrumentIdentifierApi
 * PHP version 5
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * CyberSource Merged Spec
 *
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace CyberSource\Api;

use \CyberSource\ApiClient;
use \CyberSource\ApiException;
use \CyberSource\Configuration;
use \CyberSource\ObjectSerializer;

/**
 * InstrumentIdentifierApi Class Doc Comment
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class InstrumentIdentifierApi
{
    /**
     * API Client
     *
     * @var \CyberSource\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \CyberSource\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\CyberSource\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \CyberSource\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \CyberSource\ApiClient $apiClient set the API client
     *
     * @return InstrumentIdentifierApi
     */
    public function setApiClient(\CyberSource\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation deleteInstrumentIdentifier
     *
     * Delete an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of void, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteInstrumentIdentifier($instrumentIdentifierTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->deleteInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation deleteInstrumentIdentifierWithHttpInfo
     *
     * Delete an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $profileId = null)
    {
        // verify the required parameter 'instrumentIdentifierTokenId' is set
        if ($instrumentIdentifierTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $instrumentIdentifierTokenId when calling deleteInstrumentIdentifier');
        }
        if ((strlen($instrumentIdentifierTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.deleteInstrumentIdentifier, must be smaller than or equal to 32.');
        }
        if ((strlen($instrumentIdentifierTokenId) < 12)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.deleteInstrumentIdentifier, must be bigger than or equal to 12.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.deleteInstrumentIdentifier, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.deleteInstrumentIdentifier, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($instrumentIdentifierTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "instrumentIdentifierTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($instrumentIdentifierTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}'
            );

            return [$response, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getInstrumentIdentifier
     *
     * Retrieve an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function getInstrumentIdentifier($instrumentIdentifierTokenId, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->getInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getInstrumentIdentifierWithHttpInfo
     *
     * Retrieve an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function getInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $profileId = null)
    {
        // verify the required parameter 'instrumentIdentifierTokenId' is set
        if ($instrumentIdentifierTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $instrumentIdentifierTokenId when calling getInstrumentIdentifier');
        }
        if ((strlen($instrumentIdentifierTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.getInstrumentIdentifier, must be smaller than or equal to 32.');
        }
        if ((strlen($instrumentIdentifierTokenId) < 12)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.getInstrumentIdentifier, must be bigger than or equal to 12.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.getInstrumentIdentifier, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.getInstrumentIdentifier, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($instrumentIdentifierTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "instrumentIdentifierTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($instrumentIdentifierTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier',
                '/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getInstrumentIdentifierPaymentInstrumentsList
     *
     * List Payment Instruments for an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param int $offset Starting record in zero-based dataset that should be returned as the first object in the array. Default is 0. (optional, default to 0)
     * @param int $limit The maximum number that can be returned in the array starting from the offset record in zero-based dataset. Default is 20, maximum is 100. (optional, default to 20)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\PaymentInstrumentListForCustomer, HTTP status code, HTTP response headers (array of strings)
     */
    public function getInstrumentIdentifierPaymentInstrumentsList($instrumentIdentifierTokenId, $profileId = null, $offset = '0', $limit = '20')
    {
        list($response, $statusCode, $httpHeader) = $this->getInstrumentIdentifierPaymentInstrumentsListWithHttpInfo($instrumentIdentifierTokenId, $profileId, $offset, $limit);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getInstrumentIdentifierPaymentInstrumentsListWithHttpInfo
     *
     * List Payment Instruments for an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param int $offset Starting record in zero-based dataset that should be returned as the first object in the array. Default is 0. (optional, default to 0)
     * @param int $limit The maximum number that can be returned in the array starting from the offset record in zero-based dataset. Default is 20, maximum is 100. (optional, default to 20)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\PaymentInstrumentListForCustomer, HTTP status code, HTTP response headers (array of strings)
     */
    public function getInstrumentIdentifierPaymentInstrumentsListWithHttpInfo($instrumentIdentifierTokenId, $profileId = null, $offset = '0', $limit = '20')
    {
        // verify the required parameter 'instrumentIdentifierTokenId' is set
        if ($instrumentIdentifierTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $instrumentIdentifierTokenId when calling getInstrumentIdentifierPaymentInstrumentsList');
        }
        if ((strlen($instrumentIdentifierTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be smaller than or equal to 32.');
        }
        if ((strlen($instrumentIdentifierTokenId) < 12)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be bigger than or equal to 12.');
        }

        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be bigger than or equal to 36.');
        }

        if (!is_null($offset) && ($offset < 0)) {
            throw new \InvalidArgumentException('invalid value for "$offset" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be bigger than or equal to 0.');
        }

        if (!is_null($limit) && ($limit > 100)) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be smaller than or equal to 100.');
        }
        if (!is_null($limit) && ($limit < 1)) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling InstrumentIdentifierApi.getInstrumentIdentifierPaymentInstrumentsList, must be bigger than or equal to 1.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}/paymentinstruments";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // query params
        if ($offset !== null) {
            $queryParams['offset'] = $this->apiClient->getSerializer()->toQueryValue($offset);
        }
        // query params
        if ($limit !== null) {
            $queryParams['limit'] = $this->apiClient->getSerializer()->toQueryValue($limit);
        }
        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($instrumentIdentifierTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "instrumentIdentifierTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($instrumentIdentifierTokenId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\PaymentInstrumentListForCustomer',
                '/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}/paymentinstruments'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\PaymentInstrumentListForCustomer', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\PaymentInstrumentListForCustomer', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation patchInstrumentIdentifier
     *
     * Update an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param \CyberSource\Model\PatchInstrumentIdentifierRequest $patchInstrumentIdentifierRequest Specify the previous transaction ID to update. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchInstrumentIdentifier($instrumentIdentifierTokenId, $patchInstrumentIdentifierRequest, $profileId = null, $ifMatch = null)
    {
        list($response, $statusCode, $httpHeader) = $this->patchInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $patchInstrumentIdentifierRequest, $profileId, $ifMatch);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation patchInstrumentIdentifierWithHttpInfo
     *
     * Update an Instrument Identifier
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param \CyberSource\Model\PatchInstrumentIdentifierRequest $patchInstrumentIdentifierRequest Specify the previous transaction ID to update. (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @param string $ifMatch Contains an ETag value from a GET request to make the request conditional. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchInstrumentIdentifierWithHttpInfo($instrumentIdentifierTokenId, $patchInstrumentIdentifierRequest, $profileId = null, $ifMatch = null)
    {
        // verify the required parameter 'instrumentIdentifierTokenId' is set
        if ($instrumentIdentifierTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $instrumentIdentifierTokenId when calling patchInstrumentIdentifier');
        }
        if ((strlen($instrumentIdentifierTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be smaller than or equal to 32.');
        }
        if ((strlen($instrumentIdentifierTokenId) < 12)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be bigger than or equal to 12.');
        }

        // verify the required parameter 'patchInstrumentIdentifierRequest' is set
        if ($patchInstrumentIdentifierRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $patchInstrumentIdentifierRequest when calling patchInstrumentIdentifier');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be bigger than or equal to 36.');
        }

        if (!is_null($ifMatch) && (strlen($ifMatch) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be smaller than or equal to 32.');
        }
        if (!is_null($ifMatch) && (strlen($ifMatch) < 1)) {
            throw new \InvalidArgumentException('invalid length for "$ifMatch" when calling InstrumentIdentifierApi.patchInstrumentIdentifier, must be bigger than or equal to 1.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // header params
        if ($ifMatch !== null) {
            $headerParams['if-match'] = $this->apiClient->getSerializer()->toHeaderValue($ifMatch);
        }
        // path params
        if ($instrumentIdentifierTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "instrumentIdentifierTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($instrumentIdentifierTokenId),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($patchInstrumentIdentifierRequest)) {
            $_tempBody = $patchInstrumentIdentifierRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PATCH',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier',
                '/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 412:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation postInstrumentIdentifier
     *
     * Create an Instrument Identifier
     *
     * @param \CyberSource\Model\PostInstrumentIdentifierRequest $postInstrumentIdentifierRequest Specify either a Card, Bank Account or Enrollable Card (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function postInstrumentIdentifier($postInstrumentIdentifierRequest, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->postInstrumentIdentifierWithHttpInfo($postInstrumentIdentifierRequest, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation postInstrumentIdentifierWithHttpInfo
     *
     * Create an Instrument Identifier
     *
     * @param \CyberSource\Model\PostInstrumentIdentifierRequest $postInstrumentIdentifierRequest Specify either a Card, Bank Account or Enrollable Card (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier, HTTP status code, HTTP response headers (array of strings)
     */
    public function postInstrumentIdentifierWithHttpInfo($postInstrumentIdentifierRequest, $profileId = null)
    {
        // verify the required parameter 'postInstrumentIdentifierRequest' is set
        if ($postInstrumentIdentifierRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $postInstrumentIdentifierRequest when calling postInstrumentIdentifier');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.postInstrumentIdentifier, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.postInstrumentIdentifier, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // body params
        $_tempBody = null;
        if (isset($postInstrumentIdentifierRequest)) {
            $_tempBody = $postInstrumentIdentifierRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier',
                '/tms/v1/instrumentidentifiers'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\Tmsv2customersEmbeddedDefaultPaymentInstrumentEmbeddedInstrumentIdentifier', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation postInstrumentIdentifierEnrollment
     *
     * Enroll an Instrument Identifier for Network Tokenization
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param \CyberSource\Model\PostInstrumentIdentifierEnrollmentRequest $postInstrumentIdentifierEnrollmentRequest Specify Enrollable Card details (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of void, HTTP status code, HTTP response headers (array of strings)
     */
    public function postInstrumentIdentifierEnrollment($instrumentIdentifierTokenId, $postInstrumentIdentifierEnrollmentRequest, $profileId = null)
    {
        list($response, $statusCode, $httpHeader) = $this->postInstrumentIdentifierEnrollmentWithHttpInfo($instrumentIdentifierTokenId, $postInstrumentIdentifierEnrollmentRequest, $profileId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation postInstrumentIdentifierEnrollmentWithHttpInfo
     *
     * Enroll an Instrument Identifier for Network Tokenization
     *
     * @param string $instrumentIdentifierTokenId The TokenId of a Instrument Identifier. (required)
     * @param \CyberSource\Model\PostInstrumentIdentifierEnrollmentRequest $postInstrumentIdentifierEnrollmentRequest Specify Enrollable Card details (required)
     * @param string $profileId The id of a profile containing user specific TMS configuration. (optional)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function postInstrumentIdentifierEnrollmentWithHttpInfo($instrumentIdentifierTokenId, $postInstrumentIdentifierEnrollmentRequest, $profileId = null)
    {
        // verify the required parameter 'instrumentIdentifierTokenId' is set
        if ($instrumentIdentifierTokenId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $instrumentIdentifierTokenId when calling postInstrumentIdentifierEnrollment');
        }
        if ((strlen($instrumentIdentifierTokenId) > 32)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.postInstrumentIdentifierEnrollment, must be smaller than or equal to 32.');
        }
        if ((strlen($instrumentIdentifierTokenId) < 12)) {
            throw new \InvalidArgumentException('invalid length for "$instrumentIdentifierTokenId" when calling InstrumentIdentifierApi.postInstrumentIdentifierEnrollment, must be bigger than or equal to 12.');
        }

        // verify the required parameter 'postInstrumentIdentifierEnrollmentRequest' is set
        if ($postInstrumentIdentifierEnrollmentRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $postInstrumentIdentifierEnrollmentRequest when calling postInstrumentIdentifierEnrollment');
        }
        if (!is_null($profileId) && (strlen($profileId) > 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.postInstrumentIdentifierEnrollment, must be smaller than or equal to 36.');
        }
        if (!is_null($profileId) && (strlen($profileId) < 36)) {
            throw new \InvalidArgumentException('invalid length for "$profileId" when calling InstrumentIdentifierApi.postInstrumentIdentifierEnrollment, must be bigger than or equal to 36.');
        }

        // parse inputs
        $resourcePath = "/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}/enrollment";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // header params
        if ($profileId !== null) {
            $headerParams['profile-id'] = $this->apiClient->getSerializer()->toHeaderValue($profileId);
        }
        // path params
        if ($instrumentIdentifierTokenId !== null) {
            $resourcePath = str_replace(
                "{" . "instrumentIdentifierTokenId" . "}",
                $this->apiClient->getSerializer()->toPathValue($instrumentIdentifierTokenId),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($postInstrumentIdentifierEnrollmentRequest)) {
            $_tempBody = $postInstrumentIdentifierEnrollmentRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/tms/v1/instrumentidentifiers/{instrumentIdentifierTokenId}/enrollment'
            );

            return [$response, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 410:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 424:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
