<?php
/**
 * SymmetricKeyManagementApi
 * PHP version 5
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * CyberSource Merged Spec
 *
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace CyberSource\Api;

use \CyberSource\ApiClient;
use \CyberSource\ApiException;
use \CyberSource\Configuration;
use \CyberSource\ObjectSerializer;

/**
 * SymmetricKeyManagementApi Class Doc Comment
 *
 * @category Class
 * @package  CyberSource
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class SymmetricKeyManagementApi
{
    /**
     * API Client
     *
     * @var \CyberSource\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \CyberSource\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\CyberSource\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \CyberSource\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \CyberSource\ApiClient $apiClient set the API client
     *
     * @return SymmetricKeyManagementApi
     */
    public function setApiClient(\CyberSource\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation createV2SharedSecretKeys
     *
     * Create Shared-Secret Keys
     *
     * @param \CyberSource\Model\CreateSharedSecretKeysRequest $createSharedSecretKeysRequest  (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymPost201Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function createV2SharedSecretKeys($createSharedSecretKeysRequest)
    {
        list($response, $statusCode, $httpHeader) = $this->createV2SharedSecretKeysWithHttpInfo($createSharedSecretKeysRequest);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation createV2SharedSecretKeysWithHttpInfo
     *
     * Create Shared-Secret Keys
     *
     * @param \CyberSource\Model\CreateSharedSecretKeysRequest $createSharedSecretKeysRequest  (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymPost201Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function createV2SharedSecretKeysWithHttpInfo($createSharedSecretKeysRequest)
    {
        // verify the required parameter 'createSharedSecretKeysRequest' is set
        if ($createSharedSecretKeysRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $createSharedSecretKeysRequest when calling createV2SharedSecretKeys');
        }
        // parse inputs
        $resourcePath = "/kms/v2/keys-sym";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/hal+json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // body params
        $_tempBody = null;
        if (isset($createSharedSecretKeysRequest)) {
            $_tempBody = $createSharedSecretKeysRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\KmsV2KeysSymPost201Response',
                '/kms/v2/keys-sym'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\KmsV2KeysSymPost201Response', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\KmsV2KeysSymPost201Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse4002', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 502:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\PtsV2PaymentsPost502Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deleteBulkSymmetricKeys
     *
     * Delete one or more Symmetric keys
     *
     * @param \CyberSource\Model\DeleteBulkSymmetricKeysRequest $deleteBulkSymmetricKeysRequest  (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymDeletesPost200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteBulkSymmetricKeys($deleteBulkSymmetricKeysRequest)
    {
        list($response, $statusCode, $httpHeader) = $this->deleteBulkSymmetricKeysWithHttpInfo($deleteBulkSymmetricKeysRequest);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation deleteBulkSymmetricKeysWithHttpInfo
     *
     * Delete one or more Symmetric keys
     *
     * @param \CyberSource\Model\DeleteBulkSymmetricKeysRequest $deleteBulkSymmetricKeysRequest  (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymDeletesPost200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteBulkSymmetricKeysWithHttpInfo($deleteBulkSymmetricKeysRequest)
    {
        // verify the required parameter 'deleteBulkSymmetricKeysRequest' is set
        if ($deleteBulkSymmetricKeysRequest === null) {
            throw new \InvalidArgumentException('Missing the required parameter $deleteBulkSymmetricKeysRequest when calling deleteBulkSymmetricKeys');
        }
        // parse inputs
        $resourcePath = "/kms/v2/keys-sym/deletes";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/hal+json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // body params
        $_tempBody = null;
        if (isset($deleteBulkSymmetricKeysRequest)) {
            $_tempBody = $deleteBulkSymmetricKeysRequest;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\KmsV2KeysSymDeletesPost200Response',
                '/kms/v2/keys-sym/deletes'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\KmsV2KeysSymDeletesPost200Response', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\KmsV2KeysSymDeletesPost200Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse4002', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 502:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\PtsV2PaymentsPost502Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getKeyDetails
     *
     * Retrieves shared secret key details
     *
     * @param string $keyId Key ID. (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymGet200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function getKeyDetails($keyId)
    {
        list($response, $statusCode, $httpHeader) = $this->getKeyDetailsWithHttpInfo($keyId);
        return [$response, $statusCode, $httpHeader];
    }

    /**
     * Operation getKeyDetailsWithHttpInfo
     *
     * Retrieves shared secret key details
     *
     * @param string $keyId Key ID. (required)
     * @throws \CyberSource\ApiException on non-2xx response
     * @return array of \CyberSource\Model\KmsV2KeysSymGet200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function getKeyDetailsWithHttpInfo($keyId)
    {
        // verify the required parameter 'keyId' is set
        if ($keyId === null) {
            throw new \InvalidArgumentException('Missing the required parameter $keyId when calling getKeyDetails');
        }
        // parse inputs
        $resourcePath = "/kms/v2/keys-sym/{keyId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/hal+json;charset=utf-8']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json;charset=utf-8']);

        // path params
        if ($keyId !== null) {
            $resourcePath = str_replace(
                "{" . "keyId" . "}",
                $this->apiClient->getSerializer()->toPathValue($keyId),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\CyberSource\Model\KmsV2KeysSymGet200Response',
                '/kms/v2/keys-sym/{keyId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\CyberSource\Model\KmsV2KeysSymGet200Response', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\KmsV2KeysSymGet200Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\InlineResponse4002', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 502:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\CyberSource\Model\PtsV2PaymentsPost502Response', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
