<?php
/**
 * Ptsv2paymentsTravelInformationLodgingRoom
 *
 * PHP version 5
 *
 * @category Class
 * @package  CyberSource
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * CyberSource Merged Spec
 *
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace CyberSource\Model;

use \ArrayAccess;

/**
 * Ptsv2paymentsTravelInformationLodgingRoom Class Doc Comment
 *
 * @category    Class
 * @package     CyberSource
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Ptsv2paymentsTravelInformationLodgingRoom implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ptsv2payments_travelInformation_lodging_room';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'dailyRate' => 'string',
        'numberOfNights' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'dailyRate' => null,
        'numberOfNights' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'dailyRate' => 'dailyRate',
        'numberOfNights' => 'numberOfNights'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'dailyRate' => 'setDailyRate',
        'numberOfNights' => 'setNumberOfNights'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'dailyRate' => 'getDailyRate',
        'numberOfNights' => 'getNumberOfNights'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['dailyRate'] = isset($data['dailyRate']) ? $data['dailyRate'] : null;
        $this->container['numberOfNights'] = isset($data['numberOfNights']) ? $data['numberOfNights'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if (!is_null($this->container['numberOfNights']) && ($this->container['numberOfNights'] > 9999)) {
            $invalid_properties[] = "invalid value for 'numberOfNights', must be smaller than or equal to 9999.";
        }

        if (!is_null($this->container['numberOfNights']) && ($this->container['numberOfNights'] < 1)) {
            $invalid_properties[] = "invalid value for 'numberOfNights', must be bigger than or equal to 1.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['numberOfNights'] > 9999) {
            return false;
        }
        if ($this->container['numberOfNights'] < 1) {
            return false;
        }
        return true;
    }


    /**
     * Gets dailyRate
     * @return string
     */
    public function getDailyRate()
    {
        return $this->container['dailyRate'];
    }

    /**
     * Sets dailyRate
     * @param string $dailyRate Daily cost of the room.
     * @return $this
     */
    public function setDailyRate($dailyRate)
    {

        $this->container['dailyRate'] = $dailyRate;

        return $this;
    }

    /**
     * Gets numberOfNights
     * @return int
     */
    public function getNumberOfNights()
    {
        return $this->container['numberOfNights'];
    }

    /**
     * Sets numberOfNights
     * @param int $numberOfNights Number of nights billed at the rate specified by `travelInformation.lodging.room[].dailyRate`.
     * @return $this
     */
    public function setNumberOfNights($numberOfNights)
    {
        if (!is_null($numberOfNights) && ($numberOfNights > 9999)) {
            throw new \InvalidArgumentException('invalid value for $numberOfNights when calling Ptsv2paymentsTravelInformationLodgingRoom., must be smaller than or equal to 9999.');
        }
        if (!is_null($numberOfNights) && ($numberOfNights < 1)) {
            throw new \InvalidArgumentException('invalid value for $numberOfNights when calling Ptsv2paymentsTravelInformationLodgingRoom., must be bigger than or equal to 1.');
        }

        $this->container['numberOfNights'] = $numberOfNights;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\CyberSource\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\CyberSource\ObjectSerializer::sanitizeForSerialization($this));
    }
}


