{include file=$css_path}

<div class="form-container">
    <form action="{$action_url}" method="post" id="payment-form">
        <div class="form-header">
            <h1 class="Header-companyName">{$siteName}</h1>
            <h2 class="Header-purchaseDescription">{$title}</h2>
        </div>
        <div class="form-body">
            <div class="js_loader flat-spinner" style="display:none;"></div>
                <div class="js_form">
                    {if $_form == 'unsigned'}
                        <div class="row">
                            <div class="form-group col-md-6">
                                <label class="form-label" for="bill_to_forename">First name</label>
                                <input type="text" id="bill_to_forename" name="bill_to_forename" class="form-control" required autocomplete="off">
                            </div>  
                            <div class="form-group col-md-6">
                                <label class="form-label" for="bill_to_surname">Last name</label>
                                <input type="text" id="bill_to_surname" name="bill_to_surname" class="form-control" required autocomplete="off">
                            </div>  
                        </div>
                        <div class="form-group">
                            <label class="form-label" for="bill_to_address_line1">Address</label>
                            <input type="address" id="bill_to_address_line1" name="bill_to_address_line1" class="form-control" required autocomplete="off">
                        </div>  
                        <div class="row"> 
                            <div class="form-group col-md-6">
                                <label class="form-label" for="bill_to_address_country">Country</label>
                                <select name="bill_to_address_country" id="bill_to_address_country" class="form-control" required>
                                    {foreach from=$countries item=$name key=$code}
                                        <option value="{$code}" {if $code == 'US'}selected{/if}>{$name}</option>
                                    {/foreach}
                                </select> 
                            </div>
                            <div class="form-group col-md-6">
                                <label class="form-label" for="card_type">State</label>
                                <select name="bill_to_address_state" id="bill_to_address_state" class="form-control">
                                    {foreach from=$us_states item=$name key=$code}
                                        <option value="{$code}">{$name}</option>
                                    {/foreach}
                                </select> 
                            </div>
                        </div>
                        <div class="row"> 
                            <div class="form-group col-md-6">
                                <label class="form-label" for="bill_to_address_city">City</label>
                                <input type="address" id="bill_to_address_city" name="bill_to_address_city" class="form-control" required autocomplete="off">
                            </div>
                            <div class="form-group col-md-6">
                                <label class="form-label" for="bill_to_address_postal_code">Postal Code</label>
                                <input type="text" id="bill_to_address_postal_code" name="bill_to_address_postal_code" class="form-control" required autocomplete="off">
                            </div>  
                        </div>
                        <button name="confirm_pay" class="pay_btn" type="submit">Pay {$price_formatted}</button>
                    {else}
                        {foreach from=$transaction item=$value key=$key}
                            <input type="hidden" id="{$key}" name="{$key}" value="{$value}"/>
                        {/foreach}
                        <input type="hidden" id="card_expiry_date" name="card_expiry_date"/>
                        <div class="row"> 
                            <div class="form-group col-md-5">
                                <label class="form-label" for="card_type">Card Type</label>
                                <select name="card_type" id="card_type" class="form-control" required>
                                    {foreach from=$card_types item=$name key=$code}
                                        <option value="{$code}">{$name}</option>
                                    {/foreach}
                                </select> 
                            </div>       
                            <div class="form-group col-md-7">
                                <label class="form-label" for="card_number">Card Number</label>
                                <input type="text" id="card_number" name="card_number" class="form-control" required>
                            </div>     
                        </div>      
                        <div class="form-group">
                            <label class="form-label">Expiry Month / Year</label> 
                            <div class="row">
                                <div class="col-md-5">
                                    <select id="card_expiry_month" class="form-control" required>
                                        {for $i=1 to 12}
                                            <option value="{sprintf( '%02d', $i )}">{sprintf( '%02d', $i )}</option>
                                        {/for}
                                    </select> 
                                </div>
                                <div class="col-md-7">
                                    <select id="card_expiry_year" class="form-control" required>
                                        {for $i=date('Y') to date('Y')+10}
                                            <option value="{$i}">{$i}</option>
                                        {/for}
                                    </select>
                                </div>
                            </div>
                        </div>
                        <!-- Used to display form errors -->
                        <div id="card-errors" role="alert"></div>
                        <button name="make_payment" class="pay_btn" type="submit">Pay {$price_formatted}</button>
                    {/if}
                </div>
            <a class="back_to_order" href="/dashboard/order/{$order.id}">Back to Order</a>
        </div>
    </form>
</div>

{literal}
<script type="text/javascript">
$( document ).ready(function() {
    $('#payment-form').submit(function() {
        var form = $(this);
        if (form.is('.processing')) return false;

        var errors = new Array();
        var cardType        = $('#card_type').val();
        var cardNumber      = $('#card_number').val();
        var expirationMonth = $('#card_expiry_month').val();
        var expirationYear  = $('#card_expiry_year').val();

        if (!cardType) {
            errors.push("Please Select A Card Type");
        }

        var currentYear = new Date().getFullYear();
        if (/\D/.test(expirationMonth) || /\D/.test(expirationYear) ||
            expirationMonth > 12 ||
            expirationMonth < 1 ||
            expirationYear < currentYear ||
            expirationYear > currentYear + 20 )
        {
            errors.push("Card Expiration Date Is Invalid");
        }

        cardNumber = cardNumber.replace(/-|\s/g, '');  // replace any dashes or spaces in the card number
        if (!cardNumber) {
            errors.push("Missing Credit Card Number");
        } else if (cardNumber.length < 12 || cardNumber.length > 19 || /\D/.test(cardNumber) || !luhnCheck(cardNumber)) {
            errors.push("Card Number Is Invalid");
        }

        if (errors.length > 0) {
            $('#card-errors').html(errors.join('</li><li>')).slideDown();
            return false;
        } else {
            // no errors: animate and hide the previous errors
            $('#card-errors').slideUp();
        }

        $('.js_form').hide() && $('.js_loader').show();

        // Concatenate the month and year (mm-yyyy) as it is the format that CyberSource expects
        $('#card_expiry_date').val( expirationMonth + '-' + expirationYear );
        // get rid of any space/dash characters
        $('#card_number').val( cardNumber );
        $('#card_type').val( cardType );
    });

    function luhnCheck( cardNumber ) {
        var sum = 0;
        for ( var i = 0, ix = cardNumber.length; i < ix - 1; i++ ) {
            var weight = parseInt( cardNumber.substr( ix - ( i + 2 ), 1 ) * ( 2 - ( i % 2 ) ) );
            sum += weight < 10 ? weight : weight - 9;
        }

        return cardNumber.substr( ix - 1 ) == ( ( 10 - sum % 10 ) % 10 );
    }

});
</script>
{/literal}