{include file=$css_path}
<div class="form-container">
    <form id="payment-form" action="{$actionUrl}" method="POST">
        <input type="hidden" name="token" value="{$accessToken}">
        <input type="hidden" name="outletCode" value="{$outletCode}">
        <input type="hidden" name="merchantCode" value="{$merchantCode}">
        <input type="hidden" name="amount" value="{$amount}">
        <input type="hidden" name="orderReference" value="{$order.id}">
        <input type="hidden" name="billReference" value="{$billReference}">
        <input type="hidden" name="productType" value="order">
        <input type="hidden" name="productDescription" value="Payment of {$amount}">
        <input type="hidden" name="serviceDate" value="{$serviceDate}">
        <input type="hidden" name="ipAddress" value="{$ipAddress}">
        <input type="hidden" name="callbackUrl" value="{$base_uri}/payment/jengacheckout/callback?handle=order&nodeId={$order.id}&redirectUri={$redirectUri}">
        <input type="hidden" name="customerFirstName" value="customerFirstName">
        <input type="hidden" name="customerLastName" value="customerLastName">
        <input type="hidden" name="emailAddress" value="{$payee_email}">
        {if $user.phone}
            <input type="hidden" name="mobileNumber" value="{$user.phone}">
        {/if}
        <div class="form-header">
            <h1 class="Header-companyName">{$siteName}</h1>
            <h2 class="Header-purchaseDescription">{$title}</h2>
        </div>
        <div class="form-body">
            <div class="row">
                <div class="form-group col-md-6">
                    <label class="form-label" for="cardFirstName">First name</label>
                    <input type="text" id="cardFirstName" name="cardFirstName" class="form-control" required autocomplete="off">
                </div>  
                <div class="form-group col-md-6">
                    <label class="form-label" for="cardLastName">Last name</label>
                    <input type="text" id="cardLastName" name="cardLastName" class="form-control" required autocomplete="off">
                </div>  
            </div>
            <div class="row"> 
                <div class="form-group col-md-6">
                    <label class="form-label" for="address">Address</label>
                    <input type="address" id="address" name="address" class="form-control" required autocomplete="off">
                </div>  
                <div class="form-group col-md-6">
                    <label class="form-label" for="postalcodeZip">Postal Code</label>
                    <input type="text" id="postalcodeZip" name="postalcodeZip" class="form-control" required autocomplete="off">
                </div>  
            </div>
            <div class="row"> 
                <div class="form-group col-md-6">
                    <label class="form-label" for="country">Country</label>
                    <select name="country" id="country" class="form-control" required>
                        {foreach from=$countries item=$name key=$code}
                            <option value="{$name}" {if $code == 'US'}selected{/if}>{$name}</option>
                        {/foreach}
                    </select> 
                </div>
                <div class="form-group col-md-6">
                    <label class="form-label" for="city">City</label>
                    <input type="text" id="city" name="city" class="form-control" required autocomplete="off">
                </div>  
            </div>
            <hr>
            <div class="form-group">
                <label class="form-label" for="card-element">Card Number</label>
                <input type="text" id="cardNumber" name="cardNumber" class="form-control" required>
            </div>       
            <div class="row"> 
                <div class="form-group col-md-8">
                    <label class="form-label">Expiry Month / Year</label> 
                    <div class="row">
                        <div class="col-md-5">
                            <select id="cardExpiryMonth" name="cardExpiryMonth" class="form-control" required>
                                {for $i=1 to 12}
                                    <option value="{sprintf( '%02d', $i )}">{sprintf( '%02d', $i )}</option>
                                {/for}
                            </select> 
                        </div>
                        <div class="col-md-7">
                            <select id="cardExpiryYear" name="cardExpiryYear" class="form-control" required>
                                {for $i=date('Y') to date('Y')+10}
                                    <option value="{substr($i, -2)}">{$i}</option>
                                {/for}
                            </select>
                        </div>
                    </div>
                </div>
                <div class="form-group col-md-4">
                    <label class="form-label" for="cardSecurity">CVV</label>
                    <input type="text" id="cardSecurity" name="cardSecurity" class="form-control" size="4" maxlength="4" required>
                </div>
            </div>

            <button name="payNow" class="pay_btn" type="submit">Pay {$price_formatted}</button>
            <a class="back_to_order" href="/dashboard/order/{$order.id}">Back to Order</a>
        </div>
    </form>
</div>

{literal}
<script type="text/javascript">
$( document ).ready(function() {
    $('#payment-form').submit(function() {
        var form = $(this);
        if (form.is('.processing')) return false;

        var cardFirstName = form.find('[name="cardFirstName"]').val();
        var cardLastName = form.find('[name="cardLastName"]').val();

        form.find('[name="customerFirstName"]').val(cardFirstName);
        form.find('[name="customerLastName"]').val(cardLastName);
    });
});
</script>
{/literal}