<div class="form-container">
    <div id="payment-form"> 
        <div class="form-header">
            <h1 class="Header-companyName">{$siteName}</h1>
            <h2 class="Header-purchaseDescription">{$title}</h2>
        </div>
        <div class="form-body">
            <div class="js_loader flat-spinner" style="display:none;"></div>
            <button id="paystackJSPayButton" class="pay_btn" type="submit">Pay {$price_formatted}</button>
            <a class="back_to_order" href="/dashboard/paper/{$paper.id}/pay">Back to Paper</a>
        </div>
    </div> 
</div> 

<script src="https://js.paystack.co/v1/inline.js"></script> 

<script type="text/javascript">
    const paymentButton = document.getElementById('paystackJSPayButton');
    paymentButton.addEventListener("click", payWithPaystack, false);
    document.addEventListener('DOMContentLoaded', payWithPaystack, false);

    function payWithPaystack(e) {
        e.preventDefault();
        paymentButton.disabled = true;
        $('.js_loader').show();

        let handler = PaystackPop.setup({
            key: '{$paystack_public_key}', 
            email: '{$payee_email}',
            amount: {$amount_100},
            currency: '{$currency}',
            ref: '{$idempotency_key}',
            onClose: function(){
                paymentButton.disabled = false;
                window.location = '{$decline_url nofilter}';
            },
            callback: function(response){
                $.ajax({
                    method: "POST",
                    url: '{$callback_url}',
                    data: { 
                        handle: 'paper',
                        nodeId: '{$paper.id}',
                        customer_id: '{$user.id}',
                        currency: '{$currency}',
                        payment_method: '{$payment_method}',
                        reference: response.reference,
                    }
                })
                .done(function(response) {
                    if(response.success) {
                        window.location = '{$success_url nofilter}';
                    } else {
                        window.location = '{$decline_url nofilter}';
                    }
                });
            }
        });

        handler.openIframe();
    }
</script>