<?php

use Proxim\Application;
use Proxim\Configuration;
use Proxim\Module\Module;
use Proxim\Order\Order;
use Proxim\Tools;
use Proxim\Util\ArrayUtils;
use Proxim\Validate;

class Referral_Link extends Module
{
    public function __construct()
    {
        $this->name = 'referral_link';
        $this->icon = 'fa fa-link';
        $this->version = '1.0.0';
        $this->prox_versions_compliancy = array('min' => '1.0.0', 'max' => Application::VERSION);
        $this->author = 'Davison Pro';

        $this->bootstrap = true;
        parent::__construct();

        $this->displayName = 'Referral Link';
        $this->description = 'This addon helps you to track user referer and display referer information in the order details';
    }

    public function hookActionDispatcherBeforeRun() {
        $cookie_value = isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : "";

        if( !empty($cookie_value) && !isset($_SESSION['user_referer_link']) ) {
            $_SESSION['user_referer_link'] = $cookie_value;
        }
    }

    public function hookActionAfterOrderCreate( $payload ) {
        $order = ArrayUtils::get($payload, 'order');

        if (isset( $_SESSION['user_referer_link']) ){
            $referer_link = $_SESSION['user_referer_link'];

            Db::getInstance()->update('order', [
                    'referer_link' => $referer_link
                ],
                'order_id = ' . (int) $order->id
            );                                                                   
        }
    }
}