<?php 

class DirectPostApi {

    const APPROVED = 1;
    const DECLINED = 2;
    const ERROR = 3;

    public $login = array();

    public $order = array();

    public $billing = array();

    public $shipping = array();


    public function __construct($security_key) {
        $this->login['security_key'] = $security_key;
    }

    function doCapture($payment_token, $email, $fname, $lname, $orderid, $amount, $currency, $address1, $city, $zipcode) {
        $query  = "";
        // Login Information
        $query .= "security_key=" . $this->login['security_key'] . "&";
        $query .= "payment_token=" . $payment_token . "&";
        $query .= "email=" . $email . "&";
        $query .= "first_name=" . $fname . "&";
        $query .= "last_name=" . $lname . "&";
        $query .= "orderid=" . $orderid . "&";
        $query .= "amount=" . $amount . "&";
        $query .= "currency=" . $currency . "&";
        $query .= "address1=" . $address1 . "&";
        $query .= "city=" . $city . "&";
        $query .= "zipcode=" . $zipcode . "&";
        $query .= "type=sale";

        return $this->_doPost($query);
    }

    function _doPost($query) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://secure.networkmerchants.com/api/transact.php");
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

        curl_setopt($ch, CURLOPT_POSTFIELDS, $query);
        curl_setopt($ch, CURLOPT_POST, 1);

        if (!($data = curl_exec($ch))) {
            return self::ERROR;
        }

        curl_close($ch);
        
        $data = explode("&",$data);
        for($i=0;$i<count($data);$i++) {
            $rdata = explode("=",$data[$i]);
            $this->responses[$rdata[0]] = $rdata[1];
        }
        
        return $this->responses['response'];
    }
}