{include file=$css_path}

<div class="form-container">
    <form action="{$callback_url}" id="payment-form" method="POST" autocomplete="off">
        <input type="hidden" name="handle" value="wallet"> 
        <input type="hidden" name="nodeId" value="{$user.id}">
        <input type="hidden" name="amount" value="{$amount}">
        <input type="hidden" name="currency" value="{$currency}">
        <input type="hidden" name="idempotency_key" value="{$idempotency_key}">
        <input type="hidden" name="redirectUri" value="{$redirectUri}">
        <input type="hidden" name="payment_method" value="{$payment_method}">
        <div class="form-header">
            <h1 class="Header-companyName">{$siteName}</h1>
            <h2 class="Header-purchaseDescription">{$title}</h2>
        </div>
        <div class="form-body">
            <div class="js_loader flat-spinner" style="display:none;"></div>
            <div class="js_form">
                <div class="row">
                    <div class="form-group col-6">
                        <label class="form-label" for="first_name">First name</label>
                        <input type="text" id="first_name" name="firstname" class="form-control" required autocomplete="off">
                    </div>  
                    <div class="form-group col-6">
                        <label class="form-label" for="last_name">Last name</label>
                        <input type="text" id="last_name" name="lastname" class="form-control" required autocomplete="off">
                    </div>  
                </div>
                {if $user.logged}
                    <input type="hidden" name="email" value="{$user.email}">
                {else}
                    <div class="form-group">
                        <label class="form-label" for="email">Email</label>
                        <input type="email" id="email" name="email" class="form-control" required autocomplete="off">
                    </div>   
                {/if}
                <div class="form-group">
                    <label class="form-label" for="last_name">Address</label>
                    <input type="address" id="address" name="address" class="form-control" required autocomplete="off">
                </div>  
                <div class="form-group">
                    <label class="form-label" for="city">City</label>
                    <input type="text" id="city" name="city" class="form-control" required autocomplete="off">
                </div>  
                <div class="form-group">
                    <label class="form-label" for="zipcode">Zip Code</label>
                    <input type="text" id="zipcode" name="zipcode" class="form-control" required autocomplete="off">
                </div>  
                <div class="alert alert-info" style="font-size:15px;">Charges on your statements will appear as <strong>GradeValley441618187126</strong></div>
            </div>
            <button id="jSPayButton" class="pay_btn">Pay {$price_formatted}</button>
            <a class="back_to_order" href="/dashboard/wallet">Back to Wallet</a>
        </div>
    </form> 
</div> 

<script src="https://secure.networkmerchants.com/token/Collect.js" data-tokenization-key="{$tokenization_key}"></script>

<script type="text/javascript">
    document.addEventListener('DOMContentLoaded', function () {
        CollectJS.configure({
            'paymentSelector' : '#jSPayButton',
            'theme': 'bootstrap',
            'primaryColor': '#ff288d',
            'secondaryColor': '#ffe200',
            'buttonText': 'Pay {$price_formatted}',
            'paymentType': 'cc',
            "price": "{$amount}",
            "currency":"{$currency}",
            "country": "{$country_code}",
            'callback' : function(response) {
                $('.js_form').slideUp() && $('.js_loader').show();
                var input = document.createElement("input");
                input.type = "hidden";
                input.name = "payment_token";
                input.value = response.token;
                var form = document.getElementsByTagName("form")[0];
                form.appendChild(input);
                form.submit();
            }
        });
    });
</script>