<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta content="telephone=no" name="format-detection">
    <title>{$templateVars.subject}</title>
    <style type="text/css" data-premailer="ignore">
        @import url(https://fonts.googleapis.com/css?family=Open+Sans:300,400,500,600,700);
    </style>
    <style data-premailer="ignore">
        @media screen and (max-width: 600px) {
            u+.body {
                width: 100vw !important;
            }
        }

        a[x-apple-data-detectors] {
            color: inherit !important;
            text-decoration: none !important;
            font-size: inherit !important;
            font-family: inherit !important;
            font-weight: inherit !important;
            line-height: inherit !important;
        }
    </style>
    <!--[if mso]>
      <style type="text/css">
        body, table, td {
        	font-family: Arial, Helvetica, sans-serif !important;
        }
        
        img {
        	-ms-interpolation-mode: bicubic;
        }
        
        .box {
        	border-color: #eee !important;
        }
      </style>
    <![endif]-->
    <style type="text/css">
body {
    margin: 0;
    padding: 0;
    background-color: #f5f7fb;
    font-size: 15px;
    line-height: 160%;
    mso-line-height-rule: exactly;
    color: #444444;
    width: 100%;
  }
  
  @media only screen and (max-width: 560px) {
    body {
      font-size: 14px !important;
    }
  }
  
  body, table, td {
    font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;
  }
  
  table {
    border-collapse: collapse;
    width: 100%;
  }
  
  table:not(.main) {
    -premailer-cellpadding: 0;
    -premailer-cellspacing: 0;
  }
  
  .preheader {
    padding: 0;
    font-size: 0;
    display: none;
    max-height: 0;
    mso-hide: all;
    line-height: 0;
    color: transparent;
    height: 0;
    max-width: 0;
    opacity: 0;
    overflow: hidden;
    visibility: hidden;
    width: 0;
  }
  
  .main {
    -webkit-text-size-adjust: 100%;
    -ms-text-size-adjust: 100%;
  }
  
  .wrap {
    width: 100%;
    max-width: 640px;
    text-align: left;
  }
  
  .wrap-narrow {
    max-width: 500px;
  }
  
  .box {
    background: #ffffff;
    border-radius: 3px;
    -webkit-box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
            box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
    border: 1px solid #f0f0f0;
  }
  
  .box + .box {
    margin-top: 24px;
  }
  
  .content,
  .content-image-text {
    padding: 40px 48px;
  }
  
  @media only screen and (max-width: 560px) {
    .content,
    .content-image-text {
      padding: 24px !important;
    }
  }
  
  .content-image-text {
    padding: 24px;
  }
  
  .content-big {
    padding: 48px;
  }
  
  .content-image {
    height: 360px;
    background-position: center;
    background-size: cover;
  }
  
  @media only screen and (max-width: 560px) {
    .content-image {
      height: 100px !important;
    }
  }
  
  .content-image-sm {
    height: 200px;
  }
  
  .content-image-text {
    background-repeat: repeat;
    vertical-align: bottom;
    color: #fff;
    font-weight: 400;
  }
  
  @media only screen and (max-width: 560px) {
    .content-image-text {
      padding-top: 96px !important;
    }
  }
  
  h1, .h1,
  h2, .h2,
  h3, .h3,
  h4, .h4,
  h5, .h5 {
    font-weight: 600;
    margin: 0 0 .5em;
  }
  
  h1 a, .h1 a,
  h2 a, .h2 a,
  h3 a, .h3 a,
  h4 a, .h4 a,
  h5 a, .h5 a {
    color: inherit;
  }
  
  h1, .h1 {
    font-size: 28px;
    font-weight: 300;
    line-height: 130%;
  }
  
  @media only screen and (max-width: 560px) {
    h1, .h1 {
      font-size: 24px !important;
    }
  }
  
  h2, .h2 {
    font-size: 24px;
    font-weight: 300;
    line-height: 130%;
  }
  
  @media only screen and (max-width: 560px) {
    h2, .h2 {
      font-size: 20px !important;
    }
  }
  
  h3, .h3 {
    font-size: 20px;
    font-weight: 300;
    line-height: 120%;
  }
  
  @media only screen and (max-width: 560px) {
    h3, .h3 {
      font-size: 18px !important;
    }
  }
  
  h4, .h4 {
    font-size: 16px;
  }
  
  h5, .h5 {
    font-size: 14px;
  }
  
  hr,
  .hr {
    border: none;
    height: 1px;
    background-color: #f0f0f0;
    margin: 32px 0;
  }
  
  figure {
    margin: 0;
  }
  
  pre {
    font-family: Consolas, Monaco, Andale Mono, Ubuntu Mono, monospace;
    font-size: 12px;
    white-space: pre-wrap;
    max-width: 100%;
    word-break: break-word;
    overflow: auto;
    background: #f5f7fb;
    color: #728c96;
    border-radius: 3px;
    padding: 8px 12px;
    -moz-tab-size: 3;
      -o-tab-size: 3;
         tab-size: 3;
    margin: 0;
  }
  
  pre code {
    color: inherit;
    background: none;
    padding: 0;
    font-size: 12px;
  }
  
  code {
    color: #728c96;
    font-family: Consolas, Monaco, Andale Mono, Ubuntu Mono, monospace;
    font-weight: 400;
    font-size: 13px;
    white-space: pre-wrap;
    padding: .2em .4em;
    border-radius: 3px;
    background: #f5f7fb;
    word-break: break-word;
  }
  
  .table-pre pre {
    padding: 0 8px;
    background: transparent;
  }
  
  .table-pre td {
    font-family: Consolas, Monaco, Andale Mono, Ubuntu Mono, monospace;
    font-size: 12px;
    background: #f5f7fb;
    color: #728c96;
    padding-top: 0;
    padding-bottom: 0;
  }
  
  .table-pre .table-pre-line {
    text-align: right;
    padding: 0 12px;
    vertical-align: top;
    color: #9eb0b7;
    background: #f1f4fa;
    width: 1%;
  }
  
  .table-pre .table-pre-line-highlight-red td {
    background: #fae9e9;
    color: #cd201f;
  }
  
  .table-pre .table-pre-line-highlight-red td pre {
    color: #cd201f;
  }
  
  .table-pre .table-pre-line-highlight-green td {
    background: #eff8e6;
    color: #5eba00;
  }
  
  .table-pre .table-pre-line-highlight-green td pre {
    color: #5eba00;
  }
  
  .table-pre tr:first-child td {
    padding-top: 8px;
  }
  
  .table-pre tr:last-child td {
    padding-bottom: 8px;
  }
  
  img {
    border: 0 none;
    line-height: 100%;
    outline: none;
    text-decoration: none;
    vertical-align: baseline;
    font-size: 0;
  }
  
  a {
    color: #467fcf;
    text-decoration: none;
  }
  
  a:hover {
    text-decoration: underline;
  }
  
  a img {
    border: 0 none;
  }
  
  p, ul, ol {
    margin: 0 0 1em;
  }
  
  strong {
    font-weight: 600;
  }
  
  .row {
    table-layout: fixed;
  }
  
  .row .row {
    height: 100%;
  }
  
  .row-flex {
    table-layout: auto;
  }
  
  .col,
  .col-mobile,
  .col-spacer {
    vertical-align: top;
  }
  
  .col-spacer,
  .col-mobile-spacer {
    width: 24px;
  }
  
  .col-spacer-sm,
  .col-mobile-spacer-sm {
    width: 16px;
  }
  
  .col-spacer-xs,
  .col-mobile-spacer-xs {
    width: 8px;
  }
  
  .col-hr,
  .col-mobile-hr {
    width: 1px !important;
    border-left: 16px solid #fff;
    border-right: 16px solid #fff;
    background: #f0f0f0;
  }
  
  @media only screen and (max-width: 560px) {
    .col,
    .col-spacer,
    .col-spacer-xs,
    .col-spacer-sm,
    .col-hr,
    .row {
      display: table !important;
      width: 100% !important;
    }
    .col-hr {
      border: 0 !important;
      height: 24px !important;
      width: auto !important;
      background: transparent !important;
    }
    .col-spacer {
      width: 100% !important;
      height: 24px !important;
    }
    .col-spacer-sm {
      height: 16px !important;
    }
    .col-spacer-xs {
      height: 8px !important;
    }
  }
  
  .table td,
  .table th {
    padding: 4px 12px;
  }
  
  .table tr > td:first-child,
  .table tr > th:first-child {
    padding-left: 0;
  }
  
  .table tr > td:last-child,
  .table tr > th:last-child {
    padding-right: 0;
  }
  
  .table th {
    text-transform: uppercase;
    font-weight: 600;
    color: #9eb0b7;
    font-size: 12px;
    padding: 0 0 4px 0;
  }
  
  .table-vtop td, .table-vtop th {
    vertical-align: top;
  }
  
  .table-data th,
  .table-data td {
    padding: 4px 4px;
  }
  
  .avatar {
    border-radius: 50%;
    -webkit-box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
            box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
  }
  
  .avatar-rounded {
    border-radius: 3px;
  }
  
  .status {
    border-radius: 3px;
    font-weight: 300;
    vertical-align: -1px;
    color: #fff;
    width: 12px;
    height: 12px;
    margin: 0 4px 0 0;
    display: inline-block;
    background-color: #9eb0b7;
  }
  
  .quote {
    background: #fafafa;
    padding: 8px 12px;
    border-radius: 3px;
    display: inline-block;
  }
  
  .list-item > td {
    padding-top: 8px;
    padding-bottom: 8px;
  }
  
  .list-md .list-item > td {
    padding-top: 16px;
    padding-bottom: 16px;
  }
  
  .list-item + .list-item {
    border-top: 1px solid #f0f0f0;
  }
  
  .list-item:first-child > td {
    padding-top: 0;
  }
  
  .list-item:last-child > td {
    padding-bottom: 0;
  }
  
  .list-centered {
    text-align: center;
  }
  
  .list-centered > a {
    margin: 0 16px;
  }
  
  .alert {
    padding: 8px 16px;
    border-radius: 3px;
    font-weight: 400;
  }
  
  .icon {
    padding: 0;
    border-radius: 50%;
    background: #f3f6f6;
    line-height: 100%;
    font-weight: 300;
    width: 32px;
    height: 32px;
    font-size: 20px;
    border-collapse: separate;
    text-align: center;
  }
  
  .icon img {
    display: block;
  }
  
  .icon-md {
    width: 54px;
    height: 54px;
    font-size: 32px;
  }
  
  .icon-md.icon-border {
    border-width: 1px;
  }
  
  .icon-lg {
    width: 72px;
    height: 72px;
    font-size: 48px;
  }
  
  .icon-lg.icon-border {
    border-width: 2px;
  }
  
  .icon-lg img {
    width: 40px;
    height: 40px;
  }
  
  .icon-border {
    background: transparent;
    border: 1px solid #f0f0f0;
  }
  
  .chart {
    table-layout: fixed;
  }
  
  .chart-cell {
    padding: 0;
    margin: 0;
    text-align: left;
    vertical-align: bottom;
  }
  
  .chart-cell-spacer {
    width: 4px;
  }
  
  @media only screen and (max-width: 560px) {
    .chart-cell-spacer {
      width: 4px !important;
    }
  }
  
  .chart-bar {
    margin: 0;
  }
  
  .chart-bar-series {
    font-size: 0;
    padding: 0;
    margin: 0;
    line-height: 0;
    background-color: #9eb0b7;
    text-align: left;
  }
  
  .chart-label,
  .chart-bar-label {
    color: #9eb0b7;
    font-size: 12px;
    text-align: center;
    padding: 6px 0 0;
    line-height: 100%;
  }
  
  .chart-bar-label {
    padding: 0 0 4px;
    font-size: 10px;
    color: #444444;
  }
  
  .chart-percentage {
    font-size: 0;
    height: 16px;
  }
  
  .chart-percentage:first-child {
    border-radius: 2px 0 0 2px;
  }
  
  .chart-percentage:last-child {
    border-radius: 0 2px 2px 0;
  }
  
  .progress {
    height: 8px;
  }
  
  .progress td:first-child {
    border-radius: 3px 0 0 3px;
  }
  
  .progress td:last-child {
    border-radius: 0 3px 3px 0;
  }
  
  .progress-sm {
    height: 4px;
  }
  
  .calendar {
    text-align: center;
    font-size: 11px;
    line-height: 100%;
  }
  
  .calendar td {
    padding: 1px;
  }
  
  .calendar-day {
    background: #fafafa;
  }
  
  .calendar-day.other-month {
    border-color: transparent;
    color: #bbc8cd;
    background: transparent;
  }
  
  .calendar-day td {
    padding: 5px 0;
  }
  
  .calendar-md {
    font-size: 14px;
  }
  
  .calendar-md .calendar-day td {
    padding: 10px 0;
  }
  
  .calendar-lg {
    font-size: 16px;
  }
  
  .calendar-lg .calendar-day td {
    padding: 24px 0;
  }
  
  .day {
    width: 72px;
    text-align: center;
    border-radius: 3px;
    line-height: 100%;
    border: 1px solid rgba(0, 0, 0, 0.1);
    border-collapse: separate;
    background: #fff;
  }
  
  .day-weekday {
    color: #9eb0b7;
    font-size: 12px;
    text-transform: uppercase;
    padding: 0 0 4px;
    font-weight: 400;
  }
  
  .day-number {
    font-size: 32px;
    padding: 8px 0;
  }
  
  .day-month {
    background: #cd201f;
    border-radius: 3px 3px 0 0;
    color: #ffffff;
    font-weight: 400;
    text-transform: uppercase;
    font-size: 12px;
    padding: 4px 0;
  }
  
  .highlight .hll {
    background-color: #ffffcc;
  }
  
  .highlight .c {
    color: #999988;
    font-style: italic;
  }
  
  /* Comment */
  .highlight .err {
    color: #a61717;
    background-color: #e3d2d2;
  }
  
  /* Error */
  .highlight .k {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword */
  .highlight .o {
    color: #000000;
    font-weight: bold;
  }
  
  /* Operator */
  .highlight .cm {
    color: #999988;
    font-style: italic;
  }
  
  /* Comment.Multiline */
  .highlight .cp {
    color: #999999;
    font-weight: bold;
    font-style: italic;
  }
  
  /* Comment.Preproc */
  .highlight .c1 {
    color: #999988;
    font-style: italic;
  }
  
  /* Comment.Single */
  .highlight .cs {
    color: #999999;
    font-weight: bold;
    font-style: italic;
  }
  
  /* Comment.Special */
  .highlight .gd {
    color: #000000;
    background-color: #ffdddd;
  }
  
  /* Generic.Deleted */
  .highlight .ge {
    color: #000000;
    font-style: italic;
  }
  
  /* Generic.Emph */
  .highlight .gr {
    color: #aa0000;
  }
  
  /* Generic.Error */
  .highlight .gh {
    color: #999999;
  }
  
  /* Generic.Heading */
  .highlight .gi {
    color: #000000;
    background-color: #ddffdd;
  }
  
  /* Generic.Inserted */
  .highlight .go {
    color: #888888;
  }
  
  /* Generic.Output */
  .highlight .gp {
    color: #555555;
  }
  
  /* Generic.Prompt */
  .highlight .gs {
    font-weight: bold;
  }
  
  /* Generic.Strong */
  .highlight .gu {
    color: #aaaaaa;
  }
  
  /* Generic.Subheading */
  .highlight .gt {
    color: #aa0000;
  }
  
  /* Generic.Traceback */
  .highlight .kc {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword.Constant */
  .highlight .kd {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword.Declaration */
  .highlight .kn {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword.Namespace */
  .highlight .kp {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword.Pseudo */
  .highlight .kr {
    color: #000000;
    font-weight: bold;
  }
  
  /* Keyword.Reserved */
  .highlight .kt {
    color: #445588;
    font-weight: bold;
  }
  
  /* Keyword.Type */
  .highlight .m {
    color: #009999;
  }
  
  /* Literal.Number */
  .highlight .s {
    color: #d01040;
  }
  
  /* Literal.String */
  .highlight .na {
    color: #008080;
  }
  
  /* Name.Attribute */
  .highlight .nb {
    color: #0086B3;
  }
  
  /* Name.Builtin */
  .highlight .nc {
    color: #445588;
    font-weight: bold;
  }
  
  /* Name.Class */
  .highlight .no {
    color: #008080;
  }
  
  /* Name.Constant */
  .highlight .nd {
    color: #3c5d5d;
    font-weight: bold;
  }
  
  /* Name.Decorator */
  .highlight .ni {
    color: #800080;
  }
  
  /* Name.Entity */
  .highlight .ne {
    color: #990000;
    font-weight: bold;
  }
  
  /* Name.Exception */
  .highlight .nf {
    color: #990000;
    font-weight: bold;
  }
  
  /* Name.Function */
  .highlight .nl {
    color: #990000;
    font-weight: bold;
  }
  
  /* Name.Label */
  .highlight .nn {
    color: #555555;
  }
  
  /* Name.Namespace */
  .highlight .nt {
    color: #000080;
  }
  
  /* Name.Tag */
  .highlight .nv {
    color: #008080;
  }
  
  /* Name.Variable */
  .highlight .ow {
    color: #000000;
    font-weight: bold;
  }
  
  /* Operator.Word */
  .highlight .w {
    color: #bbbbbb;
  }
  
  /* Text.Whitespace */
  .highlight .mf {
    color: #009999;
  }
  
  /* Literal.Number.Float */
  .highlight .mh {
    color: #009999;
  }
  
  /* Literal.Number.Hex */
  .highlight .mi {
    color: #009999;
  }
  
  /* Literal.Number.Integer */
  .highlight .mo {
    color: #009999;
  }
  
  /* Literal.Number.Oct */
  .highlight .sb {
    color: #d01040;
  }
  
  /* Literal.String.Backtick */
  .highlight .sc {
    color: #d01040;
  }
  
  /* Literal.String.Char */
  .highlight .sd {
    color: #d01040;
  }
  
  /* Literal.String.Doc */
  .highlight .s2 {
    color: #d01040;
  }
  
  /* Literal.String.Double */
  .highlight .se {
    color: #d01040;
  }
  
  /* Literal.String.Escape */
  .highlight .sh {
    color: #d01040;
  }
  
  /* Literal.String.Heredoc */
  .highlight .si {
    color: #d01040;
  }
  
  /* Literal.String.Interpol */
  .highlight .sx {
    color: #d01040;
  }
  
  /* Literal.String.Other */
  .highlight .sr {
    color: #009926;
  }
  
  /* Literal.String.Regex */
  .highlight .s1 {
    color: #d01040;
  }
  
  /* Literal.String.Single */
  .highlight .ss {
    color: #990073;
  }
  
  /* Literal.String.Symbol */
  .highlight .bp {
    color: #999999;
  }
  
  /* Name.Builtin.Pseudo */
  .highlight .vc {
    color: #008080;
  }
  
  /* Name.Variable.Class */
  .highlight .vg {
    color: #008080;
  }
  
  /* Name.Variable.Global */
  .highlight .vi {
    color: #008080;
  }
  
  /* Name.Variable.Instance */
  .highlight .il {
    color: #009999;
  }
  
  /* Literal.Number.Integer.Long */
  .btn {
    text-decoration: none;
    white-space: nowrap;
    font-weight: 600;
    font-size: 16px;
    padding: 12px 32px;
    border-radius: 3px;
    color: #ffffff;
    line-height: 100%;
    display: block;
    border: 1px solid transparent;
    -webkit-transition: .3s background-color;
    transition: .3s background-color;
  }
  
  .btn:hover {
    text-decoration: none;
  }
  
  .btn.bg-secondary {
    color: #9eb0b7;
  }
  
  .btn.bg-secondary .btn-span {
    color: #9eb0b7;
  }
  
  .btn.bg-bordered {
    color: #467fcf;
    border-color: #467fcf;
  }
  
  .btn.bg-bordered:hover {
    background-color: #f9fbfe !important;
  }
  
  .btn.bg-bordered .btn-span {
    color: #467fcf;
  }
  
  .btn-span {
    color: #ffffff;
    font-size: 16px;
    text-decoration: none;
    white-space: nowrap;
    font-weight: 600;
    line-height: 100%;
  }
  
  .btn-block {
    display: block;
  }
  
  .btn-big {
    font-size: 17px;
    padding: 12px 24px;
    border-radius: 5px;
    text-transform: none;
  }
  
  .btn-small {
    font-size: 12px;
    padding: 8px 8px;
    line-height: 100%;
  }
  
  .btn-small .btn-span {
    font-size: 12px;
  }
  
  .badge {
    font-size: 12px;
    text-transform: uppercase;
    border-radius: 50px;
    padding: 4px 16px;
    color: #fff;
    font-weight: 700;
    background: #bbc8cd;
  }
  
  .badge-big {
    padding: 8px 24px;
    font-size: 13px;
  }
  
  /*
  Colors
   */
  .bg-white {
    background-color: #ffffff;
    color: #444444;
  }
  
  .bg-light {
    background-color: #fafafa;
  }
  
  .bg-none {
    background-color: transparent;
  }
  
  .bg-body {
    background-color: #f5f7fb;
  }
  
  .bg-dark {
    background-color: #222222;
    color: #ffffff;
  }
  
  .bg-gray {
    background-color: #f6f8fa;
  }
  
  .text-default {
    color: #444444;
  }
  
  .text-muted {
    color: #9eb0b7;
  }
  
  .text-muted-light {
    color: #bbc8cd;
  }
  
  .text-muted-dark {
    color: #728c96;
  }
  
  .bg-blue {
    background-color: #467fcf;
    color: #ffffff;
  }
  
  a.bg-blue:hover {
    background-color: #3a77cc !important;
  }
  
  .bg-blue-lightest {
    background-color: #edf2fa;
  }
  
  .bg-blue-lighter {
    background-color: #c8d9f1;
  }
  
  .bg-blue-light {
    background-color: #7ea5dd;
  }
  
  .bg-blue-dark {
    background-color: #3866a6;
  }
  
  .bg-blue-darker {
    background-color: #1c3353;
    color: #ffffff;
  }
  
  .bg-blue-darkest {
    background-color: #15263e;
    color: #ffffff;
  }
  
  .bg-blue-lt {
    color: #467fcf !important;
    background: #c8d9f1 !important;
  }
  
  .text-blue {
    color: #467fcf;
  }
  
  .border-blue {
    border-color: #467fcf;
  }
  
  .bg-azure {
    background-color: #45aaf2;
    color: #ffffff;
  }
  
  a.bg-azure:hover {
    background-color: #37a3f1 !important;
  }
  
  .bg-azure-lightest {
    background-color: #ecf7fe;
  }
  
  .bg-azure-lighter {
    background-color: #c7e6fb;
  }
  
  .bg-azure-light {
    background-color: #7dc4f6;
  }
  
  .bg-azure-dark {
    background-color: #3788c2;
  }
  
  .bg-azure-darker {
    background-color: #1c4461;
    color: #ffffff;
  }
  
  .bg-azure-darkest {
    background-color: #153349;
    color: #ffffff;
  }
  
  .bg-azure-lt {
    color: #45aaf2 !important;
    background: #c7e6fb !important;
  }
  
  .text-azure {
    color: #45aaf2;
  }
  
  .border-azure {
    border-color: #45aaf2;
  }
  
  .bg-indigo {
    background-color: #6574cd;
    color: #ffffff;
  }
  
  a.bg-indigo:hover {
    background-color: #596ac9 !important;
  }
  
  .bg-indigo-lightest {
    background-color: #f0f1fa;
  }
  
  .bg-indigo-lighter {
    background-color: #d1d5f0;
  }
  
  .bg-indigo-light {
    background-color: #939edc;
  }
  
  .bg-indigo-dark {
    background-color: #515da4;
  }
  
  .bg-indigo-darker {
    background-color: #282e52;
    color: #ffffff;
  }
  
  .bg-indigo-darkest {
    background-color: #1e233e;
    color: #ffffff;
  }
  
  .bg-indigo-lt {
    color: #6574cd !important;
    background: #d1d5f0 !important;
  }
  
  .text-indigo {
    color: #6574cd;
  }
  
  .border-indigo {
    border-color: #6574cd;
  }
  
  .bg-purple {
    background-color: #a55eea;
    color: #ffffff;
  }
  
  a.bg-purple:hover {
    background-color: #9d50e8 !important;
  }
  
  .bg-purple-lightest {
    background-color: #f6effd;
  }
  
  .bg-purple-lighter {
    background-color: #e4cff9;
  }
  
  .bg-purple-light {
    background-color: #c08ef0;
  }
  
  .bg-purple-dark {
    background-color: #844bbb;
  }
  
  .bg-purple-darker {
    background-color: #42265e;
    color: #ffffff;
  }
  
  .bg-purple-darkest {
    background-color: #321c46;
    color: #ffffff;
  }
  
  .bg-purple-lt {
    color: #a55eea !important;
    background: #e4cff9 !important;
  }
  
  .text-purple {
    color: #a55eea;
  }
  
  .border-purple {
    border-color: #a55eea;
  }
  
  .bg-pink {
    background-color: #f66d9b;
    color: #ffffff;
  }
  
  a.bg-pink:hover {
    background-color: #f55f91 !important;
  }
  
  .bg-pink-lightest {
    background-color: #fef0f5;
  }
  
  .bg-pink-lighter {
    background-color: #fcd3e1;
  }
  
  .bg-pink-light {
    background-color: #f999b9;
  }
  
  .bg-pink-dark {
    background-color: #c5577c;
  }
  
  .bg-pink-darker {
    background-color: #622c3e;
    color: #ffffff;
  }
  
  .bg-pink-darkest {
    background-color: #4a212f;
    color: #ffffff;
  }
  
  .bg-pink-lt {
    color: #f66d9b !important;
    background: #fcd3e1 !important;
  }
  
  .text-pink {
    color: #f66d9b;
  }
  
  .border-pink {
    border-color: #f66d9b;
  }
  
  .bg-red {
    background-color: #cd201f;
    color: #ffffff;
  }
  
  a.bg-red:hover {
    background-color: #c01e1d !important;
  }
  
  .bg-red-lightest {
    background-color: #fae9e9;
  }
  
  .bg-red-lighter {
    background-color: #f0bcbc;
  }
  
  .bg-red-light {
    background-color: #dc6362;
  }
  
  .bg-red-dark {
    background-color: #a41a19;
  }
  
  .bg-red-darker {
    background-color: #520d0c;
    color: #ffffff;
  }
  
  .bg-red-darkest {
    background-color: #3e0a09;
    color: #ffffff;
  }
  
  .bg-red-lt {
    color: #cd201f !important;
    background: #f0bcbc !important;
  }
  
  .text-red {
    color: #cd201f;
  }
  
  .border-red {
    border-color: #cd201f;
  }
  
  .bg-orange {
    background-color: #fd9644;
    color: #ffffff;
  }
  
  a.bg-orange:hover {
    background-color: #fd8e35 !important;
  }
  
  .bg-orange-lightest {
    background-color: #fff5ec;
  }
  
  .bg-orange-lighter {
    background-color: #fee0c7;
  }
  
  .bg-orange-light {
    background-color: #feb67c;
  }
  
  .bg-orange-dark {
    background-color: #ca7836;
  }
  
  .bg-orange-darker {
    background-color: #653c1b;
    color: #ffffff;
  }
  
  .bg-orange-darkest {
    background-color: #4c2d14;
    color: #ffffff;
  }
  
  .bg-orange-lt {
    color: #fd9644 !important;
    background: #fee0c7 !important;
  }
  
  .text-orange {
    color: #fd9644;
  }
  
  .border-orange {
    border-color: #fd9644;
  }
  
  .bg-yellow {
    background-color: #f1c40f;
    color: #ffffff;
  }
  
  a.bg-yellow:hover {
    background-color: #e3b90d !important;
  }
  
  .bg-yellow-lightest {
    background-color: #fef9e7;
  }
  
  .bg-yellow-lighter {
    background-color: #fbedb7;
  }
  
  .bg-yellow-light {
    background-color: #f5d657;
  }
  
  .bg-yellow-dark {
    background-color: #c19d0c;
  }
  
  .bg-yellow-darker {
    background-color: #604e06;
    color: #ffffff;
  }
  
  .bg-yellow-darkest {
    background-color: #483b05;
    color: #ffffff;
  }
  
  .bg-yellow-lt {
    color: #f1c40f !important;
    background: #fbedb7 !important;
  }
  
  .text-yellow {
    color: #f1c40f;
  }
  
  .border-yellow {
    border-color: #f1c40f;
  }
  
  .bg-lime {
    background-color: #7bd235;
    color: #ffffff;
  }
  
  a.bg-lime:hover {
    background-color: #73cb2d !important;
  }
  
  .bg-lime-lightest {
    background-color: #f2fbeb;
  }
  
  .bg-lime-lighter {
    background-color: #d7f2c2;
  }
  
  .bg-lime-light {
    background-color: #a3e072;
  }
  
  .bg-lime-dark {
    background-color: #62a82a;
  }
  
  .bg-lime-darker {
    background-color: #315415;
    color: #ffffff;
  }
  
  .bg-lime-darkest {
    background-color: #253f10;
    color: #ffffff;
  }
  
  .bg-lime-lt {
    color: #7bd235 !important;
    background: #d7f2c2 !important;
  }
  
  .text-lime {
    color: #7bd235;
  }
  
  .border-lime {
    border-color: #7bd235;
  }
  
  .bg-green {
    background-color: #5eba00;
    color: #ffffff;
  }
  
  a.bg-green:hover {
    background-color: #56ab00 !important;
  }
  
  .bg-green-lightest {
    background-color: #eff8e6;
  }
  
  .bg-green-lighter {
    background-color: #cfeab3;
  }
  
  .bg-green-light {
    background-color: #8ecf4d;
  }
  
  .bg-green-dark {
    background-color: #4b9500;
  }
  
  .bg-green-darker {
    background-color: #264a00;
    color: #ffffff;
  }
  
  .bg-green-darkest {
    background-color: #1c3800;
    color: #ffffff;
  }
  
  .bg-green-lt {
    color: #5eba00 !important;
    background: #cfeab3 !important;
  }
  
  .text-green {
    color: #5eba00;
  }
  
  .border-green {
    border-color: #5eba00;
  }
  
  .bg-teal {
    background-color: #2bcbba;
    color: #ffffff;
  }
  
  a.bg-teal:hover {
    background-color: #28beae !important;
  }
  
  .bg-teal-lightest {
    background-color: #eafaf8;
  }
  
  .bg-teal-lighter {
    background-color: #bfefea;
  }
  
  .bg-teal-light {
    background-color: #6bdbcf;
  }
  
  .bg-teal-dark {
    background-color: #22a295;
  }
  
  .bg-teal-darker {
    background-color: #11514a;
    color: #ffffff;
  }
  
  .bg-teal-darkest {
    background-color: #0d3d38;
    color: #ffffff;
  }
  
  .bg-teal-lt {
    color: #2bcbba !important;
    background: #bfefea !important;
  }
  
  .text-teal {
    color: #2bcbba;
  }
  
  .border-teal {
    border-color: #2bcbba;
  }
  
  .bg-cyan {
    background-color: #17a2b8;
    color: #ffffff;
  }
  
  a.bg-cyan:hover {
    background-color: #1596aa !important;
  }
  
  .bg-cyan-lightest {
    background-color: #e8f6f8;
  }
  
  .bg-cyan-lighter {
    background-color: #b9e3ea;
  }
  
  .bg-cyan-light {
    background-color: #5dbecd;
  }
  
  .bg-cyan-dark {
    background-color: #128293;
  }
  
  .bg-cyan-darker {
    background-color: #09414a;
    color: #ffffff;
  }
  
  .bg-cyan-darkest {
    background-color: #073137;
    color: #ffffff;
  }
  
  .bg-cyan-lt {
    color: #17a2b8 !important;
    background: #b9e3ea !important;
  }
  
  .text-cyan {
    color: #17a2b8;
  }
  
  .border-cyan {
    border-color: #17a2b8;
  }
  
  .bg-gray {
    background-color: #9eb0b7;
    color: #ffffff;
  }
  
  a.bg-gray:hover {
    background-color: #95a9b0 !important;
  }
  
  .bg-gray-lightest {
    background-color: #f5f7f8;
  }
  
  .bg-gray-lighter {
    background-color: #e2e7e9;
  }
  
  .bg-gray-light {
    background-color: #bbc8cd;
  }
  
  .bg-gray-dark {
    background-color: #7e8d92;
  }
  
  .bg-gray-darker {
    background-color: #3f4649;
    color: #ffffff;
  }
  
  .bg-gray-darkest {
    background-color: #2f3537;
    color: #ffffff;
  }
  
  .bg-gray-lt {
    color: #9eb0b7 !important;
    background: #e2e7e9 !important;
  }
  
  .text-gray {
    color: #9eb0b7;
  }
  
  .border-gray {
    border-color: #9eb0b7;
  }
  
  .bg-secondary {
    background-color: #f5f7f8;
    color: #ffffff;
  }
  
  a.bg-secondary:hover {
    background-color: #ecf0f2 !important;
  }
  
  .bg-secondary-lightest {
    background-color: #fefefe;
  }
  
  .bg-secondary-lighter {
    background-color: #fcfdfd;
  }
  
  .bg-secondary-light {
    background-color: #f8f9fa;
  }
  
  .bg-secondary-dark {
    background-color: #c4c6c6;
  }
  
  .bg-secondary-darker {
    background-color: #626363;
    color: #ffffff;
  }
  
  .bg-secondary-darkest {
    background-color: #4a4a4a;
    color: #ffffff;
  }
  
  .bg-secondary-lt {
    color: #f5f7f8 !important;
    background: #fcfdfd !important;
  }
  
  .text-secondary {
    color: #f5f7f8;
  }
  
  .border-secondary {
    border-color: #f5f7f8;
  }
  
  .bg-facebook {
    background-color: #3b5998;
    color: #ffffff;
  }
  
  .bg-twitter {
    background-color: #1da1f2;
    color: #ffffff;
  }
  
  .bg-google {
    background-color: #dc4e41;
    color: #ffffff;
  }
  
  .bg-youtube {
    background-color: #f00;
    color: #ffffff;
  }
  
  .bg-vimeo {
    background-color: #1ab7ea;
    color: #ffffff;
  }
  
  .bg-dribbble {
    background-color: #ea4c89;
    color: #ffffff;
  }
  
  .bg-github {
    background-color: #181717;
    color: #ffffff;
  }
  
  .bg-instagram {
    background-color: #e4405f;
    color: #ffffff;
  }
  
  .bg-pinterest {
    background-color: #bd081c;
    color: #ffffff;
  }
  
  .bg-vk {
    background-color: #6383a8;
    color: #ffffff;
  }
  
  .bg-rss {
    background-color: #ffa500;
    color: #ffffff;
  }
  
  .bg-flickr {
    background-color: #0063dc;
    color: #ffffff;
  }
  
  .bg-bitbucket {
    background-color: #0052cc;
    color: #ffffff;
  }
  
  /*
  Text
   */
  .text-left {
    text-align: left;
  }
  
  .text-right {
    text-align: right;
  }
  
  .text-center {
    text-align: center;
  }
  
  .text-justify {
    text-align: justify;
  }
  
  .text-uppercase {
    text-transform: uppercase;
  }
  
  .text-strikethrough {
    text-decoration: line-through;
  }
  
  @media only screen and (max-width: 560px) {
    .text-mobile-center {
      text-align: center !important;
    }
    .d-mobile-none {
      display: none !important;
    }
  }
  
  .text-wrap > :first-child {
    margin-top: 0;
  }
  
  .text-wrap > :last-child {
    margin-bottom: 0;
  }
  
  /*
  Vertical align
   */
  .va-top {
    vertical-align: top;
  }
  
  .va-middle {
    vertical-align: middle;
  }
  
  .va-bottom {
    vertical-align: bottom;
  }
  
  .va-text-bottom {
    vertical-align: text-bottom;
  }
  
  /*
  Images
   */
  .img-responsive {
    max-width: 100%;
    height: auto;
  }
  
  .img-illustration {
    max-width: 240px;
    max-height: 160px;
    width: auto;
    height: auto;
  }
  
  .img-hover:hover img {
    opacity: .64;
  }
  
  .circled {
    border-radius: 50%;
  }
  
  .rounded {
    border-radius: 3px;
  }
  
  table.rounded {
    border-collapse: separate;
  }
  
  .rounded-top {
    border-top-left-radius: 3px;
    border-top-right-radius: 3px;
  }
  
  /*
  Width
   */
  .w-1p {
    width: 1%;
  }
  
  .w-33p {
    width: 33.3333%;
  }
  
  .w-50p {
    width: 50%;
  }
  
  .w-100p {
    width: 100%;
  }
  
  .w-auto {
    width: auto;
  }
  
  .h-100p {
    height: 100%;
  }
  
  /*
  Fonts
   */
  .font-sm {
    font-size: 13px;
  }
  
  .font-lg {
    font-size: 18px;
  }
  
  .font-xl {
    font-size: 21px;
  }
  
  .font-normal {
    font-weight: 400;
  }
  
  .font-strong {
    font-weight: 600;
  }
  
  .lh-narrow {
    line-height: 133.33%;
  }
  
  .lh-normal {
    line-height: 160%;
  }
  
  .lh-1 {
    line-height: 100%;
  }
  
  .lh-wide {
    line-height: 2200%;
  }
  
  /*
  Border
   */
  .border {
    border: 1px solid #f0f0f0;
  }
  
  .border-dark {
    border-color: #d1d1d1;
  }
  
  .border-top {
    border-top: 1px solid #f0f0f0;
  }
  
  .border-bottom {
    border-bottom: 1px solid #f0f0f0;
  }
  
  .border-left {
    border-left: 1px solid #f0f0f0;
  }
  
  .border-right {
    border-right: 1px solid #f0f0f0;
  }
  
  .border-dashed {
    border-style: dashed;
  }
  
  .border-wide {
    border-width: 2px;
  }
  
  /*
  Shadows
   */
  .shadow {
    -webkit-box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
            box-shadow: 0 1px 4px rgba(0, 0, 0, 0.05);
  }
  
  /*
  Margins, paddings
   */
  .m-0 {
    margin: 0;
  }
  
  .mt-0,
  .my-0 {
    margin-top: 0;
  }
  
  .mr-0,
  .mx-0 {
    margin-right: 0;
  }
  
  .mb-0,
  .my-0 {
    margin-bottom: 0;
  }
  
  .ml-0,
  .mx-0 {
    margin-left: 0;
  }
  
  .m-xs {
    margin: 4px;
  }
  
  .mt-xs,
  .my-xs {
    margin-top: 4px;
  }
  
  .mr-xs,
  .mx-xs {
    margin-right: 4px;
  }
  
  .mb-xs,
  .my-xs {
    margin-bottom: 4px;
  }
  
  .ml-xs,
  .mx-xs {
    margin-left: 4px;
  }
  
  .m-sm {
    margin: 8px;
  }
  
  .mt-sm,
  .my-sm {
    margin-top: 8px;
  }
  
  .mr-sm,
  .mx-sm {
    margin-right: 8px;
  }
  
  .mb-sm,
  .my-sm {
    margin-bottom: 8px;
  }
  
  .ml-sm,
  .mx-sm {
    margin-left: 8px;
  }
  
  .m-md {
    margin: 16px;
  }
  
  .mt-md,
  .my-md {
    margin-top: 16px;
  }
  
  .mr-md,
  .mx-md {
    margin-right: 16px;
  }
  
  .mb-md,
  .my-md {
    margin-bottom: 16px;
  }
  
  .ml-md,
  .mx-md {
    margin-left: 16px;
  }
  
  .m-lg {
    margin: 24px;
  }
  
  .mt-lg,
  .my-lg {
    margin-top: 24px;
  }
  
  .mr-lg,
  .mx-lg {
    margin-right: 24px;
  }
  
  .mb-lg,
  .my-lg {
    margin-bottom: 24px;
  }
  
  .ml-lg,
  .mx-lg {
    margin-left: 24px;
  }
  
  .m-xl {
    margin: 48px;
  }
  
  .mt-xl,
  .my-xl {
    margin-top: 48px;
  }
  
  .mr-xl,
  .mx-xl {
    margin-right: 48px;
  }
  
  .mb-xl,
  .my-xl {
    margin-bottom: 48px;
  }
  
  .ml-xl,
  .mx-xl {
    margin-left: 48px;
  }
  
  .m-xxl {
    margin: 96px;
  }
  
  .mt-xxl,
  .my-xxl {
    margin-top: 96px;
  }
  
  .mr-xxl,
  .mx-xxl {
    margin-right: 96px;
  }
  
  .mb-xxl,
  .my-xxl {
    margin-bottom: 96px;
  }
  
  .ml-xxl,
  .mx-xxl {
    margin-left: 96px;
  }
  
  .p-0 {
    padding: 0;
  }
  
  .pt-0,
  .py-0 {
    padding-top: 0;
  }
  
  .pr-0,
  .px-0 {
    padding-right: 0;
  }
  
  .pb-0,
  .py-0 {
    padding-bottom: 0;
  }
  
  .pl-0,
  .px-0 {
    padding-left: 0;
  }
  
  .p-xs {
    padding: 4px;
  }
  
  .pt-xs,
  .py-xs {
    padding-top: 4px;
  }
  
  .pr-xs,
  .px-xs {
    padding-right: 4px;
  }
  
  .pb-xs,
  .py-xs {
    padding-bottom: 4px;
  }
  
  .pl-xs,
  .px-xs {
    padding-left: 4px;
  }
  
  .p-sm {
    padding: 8px;
  }
  
  .pt-sm,
  .py-sm {
    padding-top: 8px;
  }
  
  .pr-sm,
  .px-sm {
    padding-right: 8px;
  }
  
  .pb-sm,
  .py-sm {
    padding-bottom: 8px;
  }
  
  .pl-sm,
  .px-sm {
    padding-left: 8px;
  }
  
  .p-md {
    padding: 16px;
  }
  
  .pt-md,
  .py-md {
    padding-top: 16px;
  }
  
  .pr-md,
  .px-md {
    padding-right: 16px;
  }
  
  .pb-md,
  .py-md {
    padding-bottom: 16px;
  }
  
  .pl-md,
  .px-md {
    padding-left: 16px;
  }
  
  .p-lg {
    padding: 24px;
  }
  
  .pt-lg,
  .py-lg {
    padding-top: 24px;
  }
  
  .pr-lg,
  .px-lg {
    padding-right: 24px;
  }
  
  .pb-lg,
  .py-lg {
    padding-bottom: 24px;
  }
  
  .pl-lg,
  .px-lg {
    padding-left: 24px;
  }
  
  .p-xl {
    padding: 48px;
  }
  
  .pt-xl,
  .py-xl {
    padding-top: 48px;
  }
  
  .pr-xl,
  .px-xl {
    padding-right: 48px;
  }
  
  .pb-xl,
  .py-xl {
    padding-bottom: 48px;
  }
  
  .pl-xl,
  .px-xl {
    padding-left: 48px;
  }
  
  .p-xxl {
    padding: 96px;
  }
  
  .pt-xxl,
  .py-xxl {
    padding-top: 96px;
  }
  
  .pr-xxl,
  .px-xxl {
    padding-right: 96px;
  }
  
  .pb-xxl,
  .py-xxl {
    padding-bottom: 96px;
  }
  
  .pl-xxl,
  .px-xxl {
    padding-left: 96px;
  }
  
  .h-0 {
    height: 0;
  }
  
  .w-0 {
    width: 0;
  }
  
  .h-xs {
    height: 4px;
  }
  
  .w-xs {
    width: 4px;
  }
  
  .h-sm {
    height: 8px;
  }
  
  .w-sm {
    width: 8px;
  }
  
  .h-md {
    height: 16px;
  }
  
  .w-md {
    width: 16px;
  }
  
  .h-lg {
    height: 24px;
  }
  
  .w-lg {
    width: 24px;
  }
  
  .h-xl {
    height: 48px;
  }
  
  .w-xl {
    width: 48px;
  }
  
  .h-xxl {
    height: 96px;
  }
  
  .w-xxl {
    width: 96px;
  }
  
  .d-block {
    display: block;
  }
  
  .table-fixed {
    table-layout: fixed;
  }
</style>
</head>

<body class="bg-body" style="margin: 0;padding: 0;background-color: #f5f7fb;font-size: 15px;line-height: 160%;mso-line-height-rule: exactly;color: #444444;width: 100%;font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;">
    <center>
        <table class="main bg-body" width="100%" cellspacing="0" cellpadding="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;-webkit-text-size-adjust: 100%;-ms-text-size-adjust: 100%;background-color: #f5f7fb;">
            <tr>
                <td align="center" valign="top" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;">
                    <!--[if (gte mso 9)|(IE)]>
              <table border="0" cellspacing="0" cellpadding="0">
                <tr>
                  <td align="center" valign="top" width="640">
            <![endif]-->
                    <table class="wrap" cellspacing="0" cellpadding="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;max-width: 640px;text-align: left;-premailer-cellpadding: 0;-premailer-cellspacing: 0;">
                        <tr>
                            <td class="p-sm" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;padding: 8px;">
                                <table cellpadding="0" cellspacing="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;-premailer-cellpadding: 0;-premailer-cellspacing: 0;">
                                    <tr>
                                        <td class="py-lg" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;padding-top: 24px;padding-bottom: 24px;">
                                            <table cellspacing="0" cellpadding="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;-premailer-cellpadding: 0;-premailer-cellspacing: 0;">
                                                <tr>
                                                    <td style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;">
                                                        <a href="{$templateVars.site_url}?utm_source=email" style="color: #467fcf;text-decoration: none;">
                                                            <img src="{$templateVars.site_logo}" width="300" alt="" {$templatevars.site_name} style="border: 0 none;line-height: 100%;outline: none;text-decoration: none;vertical-align: baseline;font-size: 0;">
                                                        </a>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                                <div class="main-content">
                                    
                                {extends file="mail/mail.tpl"}

                                {block name="mail_content"}
                                  <table class="box" cellpadding="0" cellspacing="0">
                                      <tr>
                                          <td>
                                              <table cellpadding="0" cellspacing="0">
                                                  <tr>
                                                      <td class="content pb-0" align="center">
                                                          <table class="icon icon-lg bg-red-lightest " cellspacing="0" cellpadding="0">
                                                              <tr>
                                                                  <td valign="middle" align="center">
                                                                      <img src="{$templateVars.site_url}/static/images/icons/icons-red-alert-triangle.png" class=" va-middle" width="40" height="40" alt="alert-triangle" />
                                                                  </td>
                                                              </tr>
                                                          </table>
                                                          <h1 class="text-center m-0 mt-md">{$templateVars.subject}</h1>
                                                      </td>
                                                  </tr>
                                                  <tr>
                                                      <td class="content">
                                                          {$templateVars.body nofilter}
                                                      </td>
                                                  </tr>
                                                  <tr>
                                                      <td class="content pt-0">
                                                          <table cellspacing="0" cellpadding="0">
                                                              <tr>
                                                                  <td align="center">
                                                                      <table cellpadding="0" cellspacing="0" border="0" class="bg-blue rounded w-auto">
                                                                          <tr>
                                                                              <td align="center" valign="top" class="lh-1">
                                                                                  <a href="{$templateVars.order_url}?utm_source=email" class="btn bg-blue border-blue">
                                                                                      <span class="btn-span">Check Order</span>
                                                                                  </a>
                                                                              </td>
                                                                          </tr>
                                                                      </table>
                                                                  </td>
                                                              </tr>
                                                          </table>
                                                      </td>
                                                  </tr>
                                              </table>
                                          </td>
                                      </tr>
                                  </table>
                                  {/block}

                                </div>
                                <table cellspacing="0" cellpadding="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;-premailer-cellpadding: 0;-premailer-cellspacing: 0;">
                                    <tr>
                                        <td class="py-xl" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;padding-top: 48px;padding-bottom: 48px;">
                                            <table class="font-sm text-center text-muted" cellspacing="0" cellpadding="0" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;border-collapse: collapse;width: 100%;color: #9eb0b7;text-align: center;font-size: 13px;-premailer-cellpadding: 0;-premailer-cellspacing: 0;">
                                                <tr>
                                                    <td class="px-lg" style="font-family: Open Sans, -apple-system, BlinkMacSystemFont, Roboto, Helvetica Neue, Helvetica, Arial, sans-serif;padding-right: 24px;padding-left: 24px;">
                                                        If you have any questions, feel free to message us at <a href="mailto:{$templateVars.site_email}" class="text-muted" style="color: #9eb0b7;text-decoration: none;">{$templateVars.site_email}</a>.
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                    <!--[if (gte mso 9)|(IE)]>
            </td>
          </tr>
        </table>
            <![endif]-->
                </td>
            </tr>
        </table>
    </center>
</body>
</html>