<!doctype html>
<html lang="en">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        {block name='head'}
            {include file='_partials/head.tpl'}
            {include file='prepapers/customize.tpl'}
        {/block}
    </head>
<body> 

    {block name='header'}
        {include file='prepapers/header.tpl'}
    {/block}

    <section class="prepaper_section">
        <div class="container">
            <div class="row">
                <article class="sample col-md-8">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{$base_uri}">Home</a></li>
                        <li class="breadcrumb-item"><a href="{$base_uri}/papers">Papers</a></li>
                        <li class="breadcrumb-item active" aria-current="page">{$prepaper.title}</li>
                    </ol>
                    <div class="sample-head">
                        <h1><span class="icon-book-open"></span>{$prepaper.title}</h1>
                        <div class="sample-head__info">
                            <div class="sample-head__preview"></div>

                            <div class="sample-head__content">
                                <p class="sample-head__name"><strong>Discipline:</strong> <a href="{$base_uri}/papers?discipline={$prepaper.discipline_id}">{$prepaper.discipline.title}</a></p>
                                <p class="sample-head__name"><strong>Type of Paper:</strong> <a href="{$base_uri}/papers?paperType={$prepaper.paperType_id}">{$prepaper.paperType.title}</a></p>
                                <p class="sample-head__name"><strong>Academic Level:</strong> <a href="{$base_uri}/papers?academicLevel={$prepaper.academicLevelId}">{$prepaper.academicLevel.title}</a></p>
                                <p class="sample-head__name"><strong>Paper Format:</strong> {$prepaper.paperFormat.title}</p>
                                <div class="sample-head__desc">
                                    <span class="sample-head__desc-item"><strong>Pages:</strong> <span class="js-count-pages">{$prepaper.pages}</span></span>
                                    <span class="sample-head__desc-item"><strong>Words:</strong> <span class="js-count-words">{$prepaper.words}</span></span>
                                </div>

                                <div class="sample-head__bottom sample-head__bottom_desktop">
                                    <a class="sample-head__link" href="{$base_uri}/dashboard/authorization?redirectAfterAuth=/paper/{$prepaper.id}/pay">Buy For {$prepaper.priceFormatted}</a>
                                    <a class="sample-head__link secondary" href="{$base_uri}/order?paper_id={$prepaper.id}">Order Custom Paper</a>
                                </div>
                            </div>
                        </div>
                        <div class="sample-head__bottom sample-head__bottom_mobile">
                            <a class="sample-head__link" href="{$base_uri}/dashboard/authorization?redirectAfterAuth=/paper/{$prepaper.id}/pay">Buy For {$prepaper.priceFormatted}</a>
                        </div>
                    </div>

                    <div class="single-essay">
                        <div class="single-essay__content">
                            <p class="single-essay__content-title">Question</p>
                            <p>{$prepaper.question nofilter}</p>
                        </div>

                        {if count($prepaper.previews)}
                            <div class="content-block">
                                <div id="prepaperPreviewControls" class="carousel slide" data-ride="carousel">
                                    <ul class="carousel-inner">
                                        {foreach from=$prepaper.previews item=$preview key=$page}
                                            <li class="carousel-item {if $page == 0}active{/if}">
                                                <img class="w-100" src="{$preview.image_source}" alt="{$preview.source}">
                                                <div class="content-block__page">Page: <b>{$page+1} of {count($prepaper.previews)}</b></div>
                                                <div class="content-block__cta">
                                                    <a href="/dashboard/authorization?redirectAfterAuth=/paper/{$prepaper.id}/pay" rel="nofollow" class="content-block__cta-link">Buy For {$prepaper.priceFormatted}</a>
                                                </div>
                                            </li>
                                        {/foreach}
                                    </ul>
                                    <a class="carousel-control-prev" href="#prepaperPreviewControls" role="button" data-slide="prev">
                                        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                                        <span class="sr-only">Previous</span>
                                    </a>
                                    <a class="carousel-control-next" href="#prepaperPreviewControls" role="button" data-slide="next">
                                        <span class="carousel-control-next-icon" aria-hidden="true"></span>
                                        <span class="sr-only">Next</span>
                                    </a>
                                </div>
                            </div>
                        {/if}
                    </div>
                </article>

                <div class="col-md-4">
                    <div class="sidebar">
                        <div class="ourwriters-4-ban">
                            <div class="ourwriters-4-ban-items">
                                <div class="ourwriters-4-ban-item">
                                    <div class="ourwriters-4-ban-item-ico ourwriters-4-ban-item-ico1"></div>
                                    <div class="ourwriters-4-ban-subtitle">Qualified writers only</div>
                                </div>
                                <div class="ourwriters-4-ban-item">
                                    <div class="ourwriters-4-ban-item-ico ourwriters-4-ban-item-ico2"></div>
                                    <div class="ourwriters-4-ban-subtitle">Plagiarism free guarantee</div>
                                </div>
                                <div class="ourwriters-4-ban-item">
                                    <div class="ourwriters-4-ban-item-ico ourwriters-4-ban-item-ico3"></div>
                                    <div class="ourwriters-4-ban-subtitle">It'll take you just 2 minutes</div>
                                </div>
                            </div>
                            <div class="ourwriters-4-ban-buttons">
                                <a rel="nofollow" class="ourwriters-4-ban-button-orange" href="{$base_uri}/order?paper_id={$prepaper.id}">Order now</a>
                                <span class="ourwriters-4-ban-or">or</span>
                                <a rel="nofollow" class="ourwriters-4-ban-button-blue" href="{$base_uri}/inquiry?paper_id={$prepaper.id}">Free inquiry</a>
                            </div>
                        </div>

                        {block name='sidebar'}
                            {include file='prepapers/sidebar.tpl'}
                        {/block}
                    </div>
                </div>
            </div>
        </div>
    </section>

    {block name='footer'}
        {include file='prepapers/footer.tpl'}
    {/block}

    {block name='javascript_bottom'}
        {include file="_partials/javascript.tpl" javascript=$javascript.bottom}
    {/block}

    <!-- Tawk.to Code -->
    {if $tawk_chat_code} {html_entity_decode($tawk_chat_code) nofilter} {/if}
    <!-- Tawk.to Code -->

</body>
</html>